// DigitalEADlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "DigitalEA.h"
#include "DigitalEADlg.h"
#include "DeviceDlg.h"
#include "opc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDigitalEADlg Dialogfeld

CDigitalEADlg::CDigitalEADlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDigitalEADlg::IDD, pParent)
    {
	//{{AFX_DATA_INIT(CDigitalEADlg)
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    }

void CDigitalEADlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDigitalEADlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDigitalEADlg, CDialog)
	//{{AFX_MSG_MAP(CDigitalEADlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CLEAR, OnClearAlarm)
	ON_WM_TIMER()
	ON_LBN_SELCHANGE(IDC_HOSTLIST, OnSelchangeHostlist)
	ON_BN_CLICKED(IDC_MODIFY, OnModify)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	ON_WM_VKEYTOITEM()
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_LBN_DBLCLK(IDC_HOSTLIST, OnModify)
	ON_WM_CANCELMODE()
	ON_BN_CLICKED(IDC_GETHELP, OnGethelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDigitalEADlg Nachrichten-Handler

BOOL CDigitalEADlg::OnInitDialog()
    {
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	    {
		CString strAboutMenu;
		strAboutMenu.LoadString( IDS_ABOUTBOX );
		if (!strAboutMenu.IsEmpty())
		    {
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		    }
	    }

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen

    // Die konfigurierten E/A-Server in die Listbox bernehmen und aktivieren.
    CDeaServ *pdea;
    for( pdea = CDeaServ::g_root; pdea != NULL; pdea = pdea->m_next )
        {
        AddServerItem( pdea );
        pdea->Activate( m_hWnd );
        }
	
    // Timer installieren, der alle 100 ms WM_TIMER schicken und damit
    // unser OnTimer() aufrufen wird.
    SetTimer( IDD_DIGITALEA_DIALOG, 100, NULL );

    // Fenster minimieren, wenn wir auf Client-Wunsch gestartet sind.
    if( FALSE )     // EDIT?
        PostMessage( WM_SYSCOMMAND, SC_MINIMIZE );

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
    }



BOOL CDigitalEADlg::OnCommand(WPARAM wParam, LPARAM lParam) 
    {
    switch( LOWORD( wParam ) )
        {
        case IDOK:
        case IDCANCEL:          // schliet Beenden durchs Schliefeld mit ein
            // Vor Beenden noch WinHelp freigeben.
            //::WinHelp( m_hWnd, "DigitalEA.hlp", HELP_QUIT, 0 );
            break;
        }

	return CDialog::OnCommand(wParam, lParam);
    }


void CDigitalEADlg::OnSysCommand(UINT nID, LPARAM lParam)
    {
    //TRACE( "SysCommand %d\n", nID );
    switch( nID & 0xFFF0 ) 
        {
        case IDM_ABOUTBOX:
            {
            CAboutDlg dlgAbout;
            dlgAbout.DoModal();
            return;
            }
        }
    // Kommandos, die wir nicht selbst behandelt haben:
    CDialog::OnSysCommand(nID, lParam);
    }

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CDigitalEADlg::OnPaint() 
    {
	if (IsIconic())
	    {
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	    }
	else
	    {
		CDialog::OnPaint();
	    }
    }

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CDigitalEADlg::OnQueryDragIcon()
    {
    return (HCURSOR) m_hIcon;
    }



void CDigitalEADlg::OnTimer(UINT nIDEvent) 
    {
    CDeaServ::MessageHandler( WM_TIMER, 0, 0 );
    }



// Den Alarm im aktuell ausgewhlten Server quittieren.

void CDigitalEADlg::OnClearAlarm() 
    {
    CDeaServ *pdea;
    int nSel;

    nSel = GetListBox()->GetCurSel();
    if( nSel != LB_ERR )
        {
        pdea = (CDeaServ *)GetListBox()->GetItemDataPtr( nSel );
        pdea->ReEnable();
        }
    }


// Das hier rufen wir auf, wenn uns unsere CDeaServ-Kinder auf nderungen
// aufmerksam gemacht haben. Wir zeigen den Status des gerade in der Listbox
// ausgewhlten Servers an.

void CDigitalEADlg::ShowServerState()
    {
    CString str, strMsg;
    CDeaServ *pdea;
    int nSel;
    int nError;
    BOOL fAlarm = FALSE;

    nSel = GetListBox()->GetCurSel();
    if( nSel == LB_ERR )
        {
        // kein Server ausgewhlt
        SetDlgItemText( IDC_STATUS, "" );
        return;
        }
    pdea = (CDeaServ *)GetListBox()->GetItemDataPtr( nSel );
    nError = pdea->m_nLastRealError;
    if( pdea->m_cfg.fDisable )
        strMsg.LoadString( IDS_DISABLED );
    else if( pdea->m_nConnState == CS_STARTED )
        strMsg.LoadString( IDS_RESOLVING );
    else if( pdea->m_nConnState == CS_READY )
        {
        if( pdea->m_drvState.kurzschluss )
            {
            strMsg.LoadString( IDS_SHUTDOWN );
            fAlarm = TRUE;
            }
        else
            {
            str.LoadString( IDS_INPUTS );
            if( pdea->GetItemQuality( DEA_HEAT, 0 ) == OPC_QUALITY_GOOD )
                strMsg.Format( "%s: %03x, T = %d C", (LPCTSTR)str,
                    pdea->m_drvState.input_reg, pdea->m_drvState.temperatur );
            else
                strMsg.Format( "%s: %03x", (LPCTSTR)str,
                    pdea->m_drvState.input_reg );
            }
        }
    else if( pdea->m_drvState.VCC != 0 && pdea->m_drvState.VCC <= 9 )
        strMsg.LoadString( IDS_BLACKOUT );
    else switch( nError )
        {
        case 0:
        case WSAETIMEDOUT:
            strMsg.LoadString( IDS_CONNECTING );
            break;
        default:
            // evtl. WSAEINVAL, ungltiger Hostname...
            if( !strMsg.LoadString( nError ) )
                strMsg.Format( "[%d] ???", nError );
        }
    SetDlgItemText( IDC_STATUS, strMsg );

    GetDlgItem( IDC_CLEAR )->EnableWindow( fAlarm );
    }


void CDigitalEADlg::OnSelchangeHostlist() 
    {
    ShowServerState();	    
    }



// Fr den ausgewhlten Server den Endgerte-Dialog ffnen.

void CDigitalEADlg::OnModify() 
    {
    CListBox *plb = GetListBox();
    int nSel;
    CDeaServ *pdea;
    CDeviceDlg dlg;

    nSel = plb->GetCurSel();
    if( nSel == LB_ERR )
        return;
    pdea = (CDeaServ *)plb->GetItemDataPtr( nSel );

    dlg.m_strTarget = pdea->m_strTarget;
    dlg.m_cfg       = pdea->m_cfg;
    if( dlg.DoModal() == IDOK )
        {
        // Das CDeaServ-Objekt zerstren.
        pdea->Disconnect();
        plb->DeleteString( nSel );
        delete pdea;
        // berprfen, ob die eingegebene Gertenummer bereits anderswo verwendet wird.
        // Wenn ja, eine Warnung erzeugen.
        for( pdea = CDeaServ::g_root; pdea != NULL; pdea = pdea->m_next )
            if( pdea->m_cfg.nId == dlg.m_cfg.nId )
                AfxMessageBox( IDS_COLLISION );
        // Neues CDeaServ-Objekt anlegen.
        pdea = new CDeaServ( dlg.m_strTarget, dlg.m_cfg );
        AddServerItem( pdea );
        pdea->Activate( m_hWnd );
        // Schaltflche "Sichern" freigeben.
        GetDlgItem( IDC_SAVE )->EnableWindow( TRUE );
	    }
    }


// ber Endgerte-Dialog einen neuen Server hinzufgen.

void CDigitalEADlg::OnAdd() 
    {
    int nMin, nMax;
    CDeaServ *pdea;
    CListBox *plb = GetListBox();
    CDeviceDlg dlg;
    CString str;

    // Unbenutzte ID-Nummer finden.
    nMin = 1000;
    nMax = 0;
    for( pdea = CDeaServ::g_root; pdea != NULL; pdea = pdea->m_next )
        {
        if( nMin > pdea->m_cfg.nId )
            nMin = pdea->m_cfg.nId;
        if( nMax < pdea->m_cfg.nId )
            nMax = pdea->m_cfg.nId;
        }
    dlg.m_cfg.nId = nMax + 1;
    if( nMin > 1 && nMin <= nMax )
        dlg.m_cfg.nId = nMin - 1;
    if( dlg.DoModal() == IDOK )
        {
        // berprfen, ob die eingegebene Gertenummer bereits anderswo verwendet wird.
        // Wenn ja, eine Warnung erzeugen.
        for( pdea = CDeaServ::g_root; pdea != NULL; pdea = pdea->m_next )
            if( pdea->m_cfg.nId == dlg.m_cfg.nId )
                AfxMessageBox( IDS_COLLISION );
        // Neuen Server erzeugen.
        pdea = new CDeaServ( dlg.m_strTarget, dlg.m_cfg );
        AddServerItem( pdea );
        pdea->Activate( m_hWnd );
        // Schaltflche "Sichern" freigeben.
        GetDlgItem( IDC_SAVE )->EnableWindow( TRUE );
	    }	
    }


// Den ausgewhlten Server lschen.

void CDigitalEADlg::OnDelete() 
    {
    CListBox *plb = GetListBox();
    int nSel;
    CDeaServ *pdea;

    nSel = plb->GetCurSel();
    if( nSel == LB_ERR )
        return;
    pdea = (CDeaServ *)plb->GetItemDataPtr( nSel );

    if( AfxMessageBox( IDS_CONFIRM_DELETE, MB_OKCANCEL ) == IDOK )
        {
        pdea->Disconnect();
        plb->DeleteString( nSel );
        delete pdea;
        // Schaltflche "Sichern" freigeben.
        GetDlgItem( IDC_SAVE )->EnableWindow( TRUE );
        }
    }


int CDigitalEADlg::OnVKeyToItem(UINT nKey, CListBox* pListBox, UINT nIndex) 
    {
    //TRACE( "Habe %d bei Index %d bekommen\n", nKey, nIndex );
    switch( nKey )
        {
        case 32:                // Space -> Eintrag editieren
            OnModify();
            return -2;
        case 46:                // "Del" -> ausgewhlten Eintrag entfernen
            OnDelete();
            return -2;          // keine weiteren Aktionen ntig
        default:
            return -1;          // ListBox selbst soll die Taste verarbeiten
        }
	
	//return CDialog::OnVKeyToItem(nKey, pListBox, nIndex);
    }


// Fgt einen E/A-Server zur Listbox hinzu.
// Erzeugt das korrekte Anzeigeformat "BoxN (hostname)" und den ItemDataPtr-
// Rckverweis auf das Server-Objekt, und markiert das neue Feld als aktiv.

void CDigitalEADlg::AddServerItem( CDeaServ *pdea )
    {
    CString str, str2;
    CListBox *plb = GetListBox();
    int nPos;

    str2.LoadString( IDS_LABEL_BOX );
    str.Format( "%s%d (%s)", (LPCTSTR)str2, pdea->m_cfg.nId, (LPCTSTR)pdea->m_strTarget );
    nPos = plb->AddString( str );
    plb->SetItemDataPtr( nPos, pdea );
    plb->SetCurSel( nPos );
    }


LRESULT CDigitalEADlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
    {
	// Meldungen der CDeaServ-Objekte abfangen und evtl. weiterleiten.
    switch( message )
        {
        case DM_UPDATED:
            // Statusanzeige im Dialogfeld aktualisieren.
            ShowServerState();
            return TRUE;
        case DM_SOCKEVENT:
        case DM_HOSTRESOLVED:
            CDeaServ::MessageHandler( message, wParam, lParam );
            ShowServerState();
            return TRUE;
        }

	return CDialog::WindowProc(message, wParam, lParam);
    }


void CDigitalEADlg::OnSave() 
    {
    ((CDigitalEAApp *)AfxGetApp())->SaveSettings();	    
    GetDlgItem( IDC_SAVE )->EnableWindow( FALSE );
    }


void CDigitalEADlg::OnGethelp() 
    {
    CAboutDlg dlgAbout;
    dlgAbout.DoModal();
    //::WinHelp( m_hWnd, "DigitalEA.hlp", HELP_CONTENTS, 0 );
    // HELP_QUIT schicken wir in OnCommand() (an der Stelle, wo wir auch prfen wrden,
    // ob Beenden zulssig ist).
    }
