Imports System.Net.Sockets
Imports System.Net
'Imports System.IO

Public Class Form1
    Public Structure IO_State
        Dim outputstate As Boolean
        Dim inputstate As Boolean
        Dim countervalue As Long
    End Structure

    Private Delegate Sub DelegateSub()
    Private connectenable As New DelegateSub(AddressOf connect_enable)
    Private disconnectenable As New DelegateSub(AddressOf disconnect_enable)
    Private formupdate As New DelegateSub(AddressOf form_update)
    Dim TCP_client As Socket
    Dim connection_ar As IAsyncResult
    Dim receivebuffer(511) As Byte
    Dim IOState(MAXI) As IO_State
    Dim cb_output(MAXO) As CheckBox
    Dim cb_input(MAXI) As CheckBox
    Dim lb_counter(MAXI) As Label
    Dim tb_counter(MAXI) As TextBox
    Dim bt_readcounter(MAXI) As Button
    Dim bt_clearcounter(MAXI) As Button

    Private Const MAXI As Integer = 11
    Private Const MAXO As Integer = 5

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim indexcount As Integer
        For indexcount = 0 To MAXO
            cb_output(indexcount) = New CheckBox
            cb_output(indexcount).Left = 17
            cb_output(indexcount).Top = 19 + indexcount * 23
            cb_output(indexcount).Width = 67
            cb_output(indexcount).Text = "Output" + Str(indexcount)
            cb_output(indexcount).Tag = indexcount
            AddHandler cb_output(indexcount).Click, AddressOf outputclick
            gb_io.Controls.Add(cb_output(indexcount))
            cb_output(indexcount).CreateControl()
        Next indexcount
        For indexcount = 0 To MAXI
            cb_input(indexcount) = New CheckBox
            cb_input(indexcount).Left = 99
            cb_input(indexcount).Top = 19 + indexcount * 23
            cb_input(indexcount).Width = 59
            cb_input(indexcount).Text = "Input" + Str(indexcount)
            gb_io.Controls.Add(cb_input(indexcount))
            cb_input(indexcount).CreateControl()
        Next indexcount
        For indexcount = 0 To MAXI
            lb_counter(indexcount) = New Label
            lb_counter(indexcount).Left = 179
            lb_counter(indexcount).Top = 19 + indexcount * 23
            lb_counter(indexcount).Width = 53
            lb_counter(indexcount).Text = "Counter" + Str(indexcount)
            gb_io.Controls.Add(lb_counter(indexcount))
            lb_counter(indexcount).CreateControl()
        Next indexcount
        For indexcount = 0 To MAXI
            tb_counter(indexcount) = New TextBox
            tb_counter(indexcount).Left = 245
            tb_counter(indexcount).Top = 19 + indexcount * 23
            tb_counter(indexcount).Width = 68
            tb_counter(indexcount).Text = "0"
            gb_io.Controls.Add(tb_counter(indexcount))
            tb_counter(indexcount).CreateControl()
        Next indexcount
        For indexcount = 0 To MAXI
            bt_readcounter(indexcount) = New Button
            bt_readcounter(indexcount).Left = 322
            bt_readcounter(indexcount).Top = 19 + indexcount * 23
            bt_readcounter(indexcount).Width = 58
            bt_readcounter(indexcount).Text = "Read"
            bt_readcounter(indexcount).Tag = indexcount
            AddHandler bt_readcounter(indexcount).Click, AddressOf readcounterclick
            gb_io.Controls.Add(bt_readcounter(indexcount))
            bt_readcounter(indexcount).CreateControl()
        Next indexcount
        For indexcount = 0 To MAXI
            bt_clearcounter(indexcount) = New Button
            bt_clearcounter(indexcount).Left = 386
            bt_clearcounter(indexcount).Top = 19 + indexcount * 23
            bt_clearcounter(indexcount).Width = 58
            bt_clearcounter(indexcount).Text = "Clear"
            bt_clearcounter(indexcount).Tag = indexcount
            AddHandler bt_clearcounter(indexcount).Click, AddressOf clearcounterclick
            gb_io.Controls.Add(bt_clearcounter(indexcount))
            bt_clearcounter(indexcount).CreateControl()
        Next indexcount
    End Sub

    '# Delegate Sub for show connect state
    Private Sub connect_enable()
        bt_connect.Enabled = False
        gb_io.Enabled = True
        bt_disconnect.Enabled = True
        Timer_polling.Enabled = True
        ToolStripStatusLabel1.Text = "Connected to " + tb_ip.Text + " : " + tb_port.Text
    End Sub

    '# Delegate Sub for show disconnect state
    Private Sub disconnect_enable()
        bt_connect.Enabled = True
        gb_io.Enabled = False
        bt_disconnect.Enabled = False
        Timer_polling.Enabled = False
        ToolStripStatusLabel1.Text = "No Connection"
    End Sub

    '# Delegate Sub for updating the inputs, outputs and counters
    Private Sub form_update()
        Dim indexcount
        For indexcount = 0 To MAXO
            If IOState(indexcount).outputstate = True Then
                cb_output(indexcount).Checked = True
            Else
                cb_output(indexcount).Checked = False
            End If
        Next
        For indexcount = 0 To MAXI
            If IOState(indexcount).inputstate = True Then
                cb_input(indexcount).Checked = True
            Else
                cb_input(indexcount).Checked = False
            End If
            tb_counter(indexcount).Text = IOState(indexcount).countervalue
        Next
    End Sub

    Private Sub bt_connect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_connect.Click
        Dim WebIOep As New IPEndPoint(IPAddress.Parse(tb_ip.Text), Val(tb_port.Text))
        If tb_ip.Text <> "" And tb_port.Text <> "" Then
            TCP_client = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
            bt_connect.Enabled = False
            Try
                TCP_client.BeginConnect(WebIOep, New AsyncCallback(AddressOf callback_connect), _
      TCP_client)
            Catch ex As Exception
            End Try
        End If
    End Sub

    '#Callback Sub for connect event
    Private Sub callback_connect(ByVal ar As IAsyncResult)
        Invoke(connectenable)
        connection_ar = ar
        Try
            TCP_client.EndConnect(ar)
            TCP_client.BeginReceive(receivebuffer, 0, 512, SocketFlags.None, New AsyncCallback(AddressOf callback_readdata), TCP_client)
        Catch ex As Exception
            closeconnections()
        End Try
    End Sub

    '#Callback Sub for receive data event 
    Private Sub callback_readdata(ByVal ar As IAsyncResult)
        If TCP_client.Connected Then
            Dim bytesread As Integer
            Dim indexcount As Integer
            Dim hexvalue As Integer
            Try
                bytesread = TCP_client.EndReceive(ar)
            Catch ex As Exception
            End Try
            If bytesread = 0 Then
                closeconnections()
            Else
                Dim receivestring As String
                receivestring = System.Text.Encoding.ASCII.GetString(receivebuffer, 0, _
                receivebuffer.Length)
                Array.Clear(receivebuffer, 0, 512)
                Try
                    TCP_client.BeginReceive(receivebuffer, 0, 512, SocketFlags.None, New AsyncCallback(AddressOf callback_readdata), TCP_client)
                Catch ex As Exception
                    closeconnections()
                End Try
                Select Case Mid(receivestring, 1, 1)
                    Case "i"    'input handling
                        hexvalue = Val("&h" + receivestring.Substring(6, bytesread - 7))
                        For indexcount = 0 To MAXI
                            If (hexvalue And 2 ^ indexcount) = 2 ^ indexcount Then
                                IOState(indexcount).inputstate = True
                            Else
                                IOState(indexcount).inputstate = False
                            End If
                        Next
                    Case "o"    'outputhandling
                        hexvalue = Val("&h" + receivestring.Substring(7, bytesread - 8))
                        For indexcount = 0 To MAXI
                            If (hexvalue And 2 ^ indexcount) = 2 ^ indexcount Then
                                IOState(indexcount).outputstate = True
                            Else
                                IOState(indexcount).outputstate = False
                            End If
                        Next
                    Case "c"    'counterhandling
                        indexcount = 0
                        If receivestring.Substring(7, 1) = ";" Then 'all counter handling
                            receivestring = receivestring.Substring(8, bytesread - 9)
                            While receivestring.IndexOf(";") > 0
                                IOState(indexcount).countervalue = Val(receivestring.Substring(0, receivestring.IndexOf(";")))
                                receivestring = receivestring.Substring(receivestring.IndexOf(";") + 1, receivestring.Length - receivestring.IndexOf(";") - 1)
                                indexcount = indexcount + 1
                            End While
                            IOState(indexcount).countervalue = Val(receivestring)
                        Else
                            For indexcount = 0 To MAXI  'single counter handling
                                If Val(receivestring.Substring(7, receivestring.IndexOf(";") - 7)) = indexcount Then _
                                   IOState(indexcount).countervalue = receivestring.Substring(InStr(receivestring, ";"), receivestring.Length - receivestring.IndexOf(";") - 1)
                            Next
                        End If
                End Select
                Invoke(formupdate)
            End If
        End If
    End Sub

    '#Sub for sending command to the Web-IO
    Private Sub sendcommand(ByVal sendstring As String)
        Dim senddata As Byte() = System.Text.Encoding.ASCII.GetBytes(sendstring)
        Try
            TCP_client.Send(senddata)
        Catch ex As Exception
            closeconnections()
        End Try
    End Sub

    'Subs for controlling the Web-IO
    Private Sub bt_outputs_read_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_outputs_read.Click
        sendcommand("GET /output?PW=" + tb_password.Text + "&")
    End Sub

    Private Sub bt_inputs_read_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_inputs_read.Click
        sendcommand("GET /input?PW=" + tb_password.Text + "&")
    End Sub

    Private Sub bt_counter_readall_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_counter_readall.Click
        sendcommand("GET /counter?PW=" + tb_password.Text + "&")
    End Sub

    Private Sub bt_counter_clearall_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_counter_clearall.Click
        sendcommand("GET /counterclear?PW=" + tb_password.Text + "&")
    End Sub

    Private Sub outputclick(ByVal sender As Object, ByVal e As System.EventArgs)
        If cb_output(sender.tag).Checked Then
            sendcommand("GET /outputaccess" + Trim(Str(sender.tag)) + "?PW=" + tb_password.Text + "&State=ON&")
        Else
            sendcommand("GET /outputaccess" + Trim(Str(sender.tag)) + "?PW=" + tb_password.Text + "&State=OFF&")
        End If
    End Sub

    Private Sub readcounterclick(ByVal sender As Object, ByVal e As System.EventArgs)
        sendcommand("GET /counter" + Trim(Str(sender.tag)) + "?PW=" + tb_password.Text + "&")
    End Sub

    Private Sub clearcounterclick(ByVal sender As Object, ByVal e As System.EventArgs)
        sendcommand("GET /counterclear" + Trim(Str(sender.tag)) + "?PW=" + tb_password.Text + "&")
    End Sub

    '#Sub for polling timer
    Private Sub Timer_polling_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer_polling.Tick
        If (cb_input_polling.Checked And TCP_client.Connected) Then
            sendcommand("GET /input?PW=" + tb_password.Text + "&")
        End If
        If (cb_output_polling.Checked And TCP_client.Connected) Then
            sendcommand("GET /output?PW=" + tb_password.Text + "&")
        End If
        If (cb_counter_polling.Checked And TCP_client.Connected) Then
            sendcommand("GET /counter?PW=" + tb_password.Text + "&")
        End If
    End Sub

    '#Sub for changing timer interval
    Private Sub tb_interval_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_interval.TextChanged
        Timer_polling.Interval = Val(tb_interval.Text)
    End Sub

    '#Subs for closing connection
    Private Sub bt_disconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_disconnect.Click
        Invoke(disconnectenable)
        closeconnections()
    End Sub

    Private Sub closeconnections()
        Try
            TCP_client.EndReceive(connection_ar)
        Catch ex As Exception
        End Try
        Try
            TCP_client.Shutdown(SocketShutdown.Both)
        Catch ex As Exception
        End Try
        Try
            TCP_client.Close()
        Catch ex As Exception
        End Try
        Invoke(disconnectenable)
    End Sub
End Class
