typedef struct _READ_REGISTER
{
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_type;
	WORD length;
} READ_REGISTER;

typedef struct _WRITE_REGISTER
{
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_type;
	WORD length;
	WORD word_anz;
	WORD value;
}WRITE_REGISTER;

typedef struct _SET_BIT
{
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_type;
	WORD length;
	WORD set_bits;
	WORD value;
} SET_BIT;

typedef struct _REGISTER_REQUEST
{
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_type;
	WORD length;
} REGISTER_REQUEST;

typedef struct _REGISTER_STATE
{
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_type;
	WORD length;
	WORD driver_id;
	WORD input_reg;
	WORD output_reg;
} REGISTER_STATE;

typedef struct _READ_COUNTER
{
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_type;
	WORD length;
	WORD counter_index;
} READ_COUNTER;

typedef struct _READ_CLEAR_COUNTER
{
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_type;
	WORD length;
	WORD counter_index;
} READ_CLEAR_COUNTER;

typedef struct _COUNTER
{
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_type;
	WORD length;
	WORD counter_index;
	long counter_value;
} COUNTER;

typedef struct _READ_ALL_COUNTER
{
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_type;
	WORD length;
} READ_ALL_COUNTER;

typedef struct _READ_CLEAR_ALL_COUNTER
{
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_type;
	WORD length;
} READ_CLEAR_ALL_COUNTER;

typedef struct _ALL_COUNTER
{
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_type;
	WORD length;
	WORD counter_count;
	long counter_value[12];
} ALL_COUNTER;

typedef struct _CLEAR_COUNTER
{
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_type;
	WORD length;
	WORD counter_index;
} CLEAR_COUNTER;
