//######################################################################
//# TCP-Client for Command string access to Web-IO 12 + 12 Digital
//######################################################################
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ScktComp;

type
  TForm1 = class(TForm)
    gb_outputs: TGroupBox;
    gb_inputs: TGroupBox;
    gb_counter: TGroupBox;
    gb_setbit: TGroupBox;
    cb_output0: TCheckBox;
    cb_output1: TCheckBox;
    cb_output2: TCheckBox;
    cb_output3: TCheckBox;
    cb_output4: TCheckBox;
    cb_output5: TCheckBox;
    cb_output6: TCheckBox;
    cb_output7: TCheckBox;
    cb_output8: TCheckBox;
    cb_output9: TCheckBox;
    cb_output10: TCheckBox;
    cb_output11: TCheckBox;
    sh_input0: TShape;
    Label1: TLabel;
    sh_input1: TShape;
    label2: TLabel;
    sh_input2: TShape;
    sh_input: TLabel;
    sh_input3: TShape;
    Label4: TLabel;
    sh_input4: TShape;
    Label5: TLabel;
    sh_input5: TShape;
    Label6: TLabel;
    sh_input6: TShape;
    Label7: TLabel;
    sh_input7: TShape;
    Label8: TLabel;
    sh_input8: TShape;
    Label9: TLabel;
    sh_input9: TShape;
    Label10: TLabel;
    sh_input10: TShape;
    Label11: TLabel;
    sh_input11: TShape;
    Label12: TLabel;
    bt_read0: TButton;
    ed_counter0: TEdit;
    bt_clear0: TButton;
    bt_read1: TButton;
    ed_counter1: TEdit;
    bt_clear1: TButton;
    bt_read2: TButton;
    ed_counter2: TEdit;
    bt_clear2: TButton;
    bt_read3: TButton;
    ed_counter3: TEdit;
    bt_clear3: TButton;
    bt_read4: TButton;
    ed_counter4: TEdit;
    bt_clear4: TButton;
    bt_read5: TButton;
    ed_counter5: TEdit;
    bt_clear5: TButton;
    bt_read6: TButton;
    ed_counter6: TEdit;
    bt_clear6: TButton;
    bt_read7: TButton;
    ed_counter7: TEdit;
    bt_clear7: TButton;
    bt_read8: TButton;
    ed_counter8: TEdit;
    bt_clear8: TButton;
    bt_read9: TButton;
    ed_counter9: TEdit;
    bt_clear9: TButton;
    bt_read10: TButton;
    ed_counter10: TEdit;
    bt_clear10: TButton;
    bt_read11: TButton;
    ed_counter11: TEdit;
    bt_clear11: TButton;
    bt_setoutputs: TButton;
    ed_setbits: TEdit;
    gb_connection: TGroupBox;
    Label13: TLabel;
    ed_ip: TEdit;
    Label14: TLabel;
    ed_port: TEdit;
    bt_connect: TButton;
    StatusBar1: TStatusBar;
    ClientSocket1: TClientSocket;
    bt_getoutputs: TButton;
    bt_getinputs: TButton;
    ed_password: TEdit;
    Label15: TLabel;
    bt_getinput: TButton;
    bt_getoutput: TButton;
    cx_input: TComboBox;
    cx_output: TComboBox;
    procedure bt_connectClick(Sender: TObject);
    procedure bt_getoutputsClick(Sender: TObject);
    procedure bt_setoutputsClick(Sender: TObject);
    procedure bt_getinputsClick(Sender: TObject);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure bt_readClick(Sender: TObject);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure bt_clearClick(Sender: TObject);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure cb_output0MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bt_getinputClick(Sender: TObject);
    procedure bt_getoutputClick(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const
  BITSET : array [0..12] of word =
      ( 1, 2, 4, 8, 16, 32,  64, 128, 256, 512, 1024, 2048, 4096);
const
  INPUT_ON = cllime;
  INPUT_OFF = clgreen;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//*** Function for converting HexString to Integer/Word Value
function HexToInt(HexString : String) : Word;
var vin_CharCount           : integer;
    vwo_HexCharValue        : Word;
    vwo_HexValue            : Word;
begin
   vwo_HexValue := 0;
   HexString := UpperCase(HexString);
   for vin_CharCount := 1 to length(HexString) do
   begin
     vwo_HexCharValue := ord(HexString[vin_CharCount]);
     if vwo_HexCharValue > 57 then
        vwo_HexCharValue := vwo_HexCharValue - 55
     else
        vwo_HexCharValue := vwo_HexCharValue - 48;
     vwo_HexCharValue := vwo_HexCharValue shl ((length(HexString) - vin_CharCount) *  4);
     vwo_HexValue := vwo_HexValue or vwo_HexCharValue;
   end;
   HexToInt := vwo_HexValue;
end;

//*** Procedure run on click to the connect button and starts TCP connection
procedure TForm1.bt_connectClick(Sender: TObject);
begin
  if clientsocket1.Active = False then
  begin
    if (ed_ip.Text <> '') and (ed_port.Text <> '') then
    begin
      ClientSocket1.Host := ed_ip.Text;
      ClientSocket1.Port := strtoint(ed_Port.Text);
      ClientSocket1.Active := True;
    end;
  end
  else
  ClientSocket1.Active := False;
end;

//*** Procedure run if connection to Web-IO takes place
procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
//*** buttons and group boxes will be enabled
  gb_outputs.Enabled := true;
  gb_inputs.Enabled := true;
  gb_counter.Enabled := true;
  gb_setbit.Enabled := true;
  bt_connect.Caption := 'disconnect';
  Statusbar1. SimpleText := 'connected to ' + ed_ip.Text + ' - port ' + ed_port.Text;
end;

//*** Procedure run if connection to Web-IO will be closed
procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
//*** buttons and group boxes will be disabled
  gb_outputs.Enabled := false;
  gb_inputs.Enabled := false;
  gb_counter.Enabled := false;
  gb_setbit.Enabled := false;
  bt_connect.Caption := 'connect';
  Statusbar1. SimpleText := 'no connection';
end;

//*** Procedure runs after receipt of data
procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var ReadString : string;
    postemp : Integer;
    pos1 : Integer;
    pos2 : Integer;
    inputval : word;
    outputval : word;
    ordvalue : integer;
    bitposition : integer;
begin
  ReadString := ClientSocket1.Socket.ReceiveText;
  postemp := 1;
  pos1 := 0;
  //** find string position of values depending on header or no header
  //'** config >> device >> basic settings >> http >> getheader
  while postemp <> 0 do
  begin
    pos2 := pos1;
    pos1 := postemp;
    postemp := pos(';', ReadString);
    if postemp > 0 then readstring[postemp] := ' ';
  end;
  //** if no header set pos2 to 0
  If pos2 = 1 Then pos2 := 0;
  ordvalue := ord(ReadString[pos2 + 1]);
  Case ordvalue of
  //** input values
    ord('i') : begin
               //** if something like "input;0123"
               If pos1 - pos2 = 6 Then
               begin
                 inputval := hextoint(copy(ReadString, pos1 + 1, 4));
                 For bitposition := 0 To 11 do
                   If (inputval And BITSET[bitposition]) = BITSET[bitposition] Then
                     (FindComponent( 'sh_input' + IntToStr( bitposition ))as tshape).brush.color := clLime
                   else
                     (FindComponent( 'sh_input' + IntToStr( bitposition ))as tshape).brush.color := clGreen;
               end;
               //** if something like "input3;ON"
               If pos1 - pos2 = 7 Then
               begin
                 bitposition := strtoint(copy(ReadString, pos2 + 6, 1));
                 If copy(ReadString, pos1 + 1, 2) = 'ON' Then
                   (FindComponent( 'sh_input' + IntToStr( bitposition ))as tshape).brush.color := clLime
                 else
                   (FindComponent( 'sh_input' + IntToStr( bitposition ))as tshape).brush.color := clGreen;
               end;
               //** if something like "input11;ON"
               If pos1 - pos2 = 8 Then
               begin
               bitposition := strtoint(copy(ReadString, pos2 + 6, 2));
               If copy(ReadString, pos1 + 1, 2) = 'ON' Then
                 (FindComponent( 'sh_input' + IntToStr( bitposition ))as tshape).brush.color := clLime
               else
                 (FindComponent( 'sh_input' + IntToStr( bitposition ))as tshape).brush.color := clGreen;
               end;
            end;
               //** output values
  ord('o'): begin
              //** if something like "output;0123"
              If pos1 - pos2 = 7 Then
              begin
                outputval := hextoint(copy(ReadString, pos1 + 1, 4));
                For bitposition := 0 To 11 do
                  If (outputval and BITSET[bitposition]) = BITSET[bitposition] Then
                    (FindComponent( 'cb_output' + IntToStr( bitposition ))as tcheckbox).checked := True
                  else
                    (FindComponent( 'cb_output' + IntToStr( bitposition ))as tcheckbox).checked := False;
              end;
              //** if something like "output3;ON"
              If pos1 - pos2 = 8 Then
              begin
                bitposition := strtoint(copy(ReadString, pos2 + 7, 1));
                If copy(ReadString, pos1 + 1, 2) = 'ON' Then
                  (FindComponent( 'cb_output' + IntToStr( bitposition ))as tcheckbox).checked := True
                else
                  (FindComponent( 'cb_output' + IntToStr( bitposition ))as tcheckbox).checked := False;
              end;
              //** if something like "output11;ON"
              If pos1 - pos2 = 9 Then
              begin
                bitposition := strtoint(copy(ReadString, pos2 + 7, 2));
                If copy(ReadString, pos1 + 1, 2) = 'ON' Then
                  (FindComponent( 'cb_output' + IntToStr( bitposition ))as tcheckbox).checked := True
                else
                  (FindComponent( 'cb_output' + IntToStr( bitposition ))as tcheckbox).checked := False;
              end;
            end;
            //** counter values
  ord('c'): begin
            //** if something like "counter3;456"
            If pos1 - pos2 = 9 Then
            begin
              bitposition := strtoint(copy(ReadString, pos1 - 1, 1));
              (FindComponent( 'ed_counter' + inttostr(bitposition)) as tedit).Text :=
              copy(ReadString, pos1 + 1, Length(ReadString) - pos1 );
            end;
            //** if something like "counter11;456"
            If pos1 - pos2 = 10 Then
            begin
              bitposition := strtoint(copy(ReadString, pos1 - 2, 2));
              (FindComponent( 'ed_counter' + inttostr(bitposition)) as tedit).Text :=
              copy(ReadString, pos1 + 1, Length(ReadString) - pos1 );
            end;
            end;
  end;
end;

//*** set outputs by using Writeregister structure
procedure TForm1.cb_output0MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  outputbitcounter : byte;
  sendstring : string;
begin
  for outputbitcounter := 0 to 11 do
  begin
    If Sender = (FindComponent( 'cb_output' + inttostr(outputbitcounter))as tcheckbox) then
    begin
      if (FindComponent( 'cb_output' + inttostr(outputbitcounter))as tcheckbox).checked then
        SendString := 'GET /outputaccess' + inttostr(outputbitcounter) + '?' +
        'PW=' + ed_password.Text + '&State=ON&'
      Else
        SendString := 'GET /outputaccess' + inttostr(outputbitcounter) + '?' +
        'PW=' + ed_password.Text + '&State=OFF&';
    end;
  end;
  ClientSocket1.socket.SendText(SendString);
end;

//*** set outputs by using SetBits structure
procedure TForm1.bt_setoutputsClick(Sender: TObject);

begin
  ClientSocket1.Socket.Sendtext('GET /outputaccess?PW='
                                + ed_password.text +'&State='+ed_setbits.Text+'&');
end;

//** read inputs
procedure TForm1.bt_getinputsClick(Sender: TObject);
begin
  ClientSocket1.Socket.Sendtext('GET /input?PW=' + ed_password.text +'&');
end;
//*** read outputs
procedure TForm1.bt_getoutputsClick(Sender: TObject);

begin
  ClientSocket1.Socket.Sendtext('GET /output?PW=' + ed_password.text +'&');
end;

//*** read single input
procedure TForm1.bt_getinputClick(Sender: TObject);
begin
  ClientSocket1.socket.Sendtext('GET /input' + cx_input.text
      + '?PW=' + ed_password.text +'&');
end;

//*** read single output
procedure TForm1.bt_getoutputClick(Sender: TObject);
begin
  ClientSocket1.socket.Sendtext('GET /output' + cx_output.text
      + '?PW=' + ed_password.text +'&');
end;

//** read single Counter
procedure TForm1.bt_readClick(Sender: TObject);
var
  outputbitcounter : byte;
begin
//** find out which button was clicked
  for outputbitcounter := 0 to 11 do
    If Sender = (FindComponent( 'bt_read' + inttostr(outputbitcounter))) then
      ClientSocket1.socket.Sendtext('GET /counter' + inttostr(outputbitcounter)
      + '?PW=' + ed_password.text +'&');
end;

// ** clear single counter
procedure TForm1.bt_clearClick(Sender: TObject);
var
  outputbitcounter : byte;
begin
//** find out which button was clicked
  for outputbitcounter := 0 to 11 do
    If Sender = (FindComponent( 'bt_clear' + inttostr(outputbitcounter))) then
      ClientSocket1.socket.Sendtext('GET /counterclear' + inttostr(outputbitcounter)
      + '?PW=' + ed_password.text +'&');
end;

// ** Error handling
procedure TForm1.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  errorcode := 0;
  showmessage('Connection Error');
end;

end.
