//######################################################################
//# TCP-Server for binary access to Web-IO 12 + 12 Digital
//# Configure Web-IO to Binary >> TCP-Client >> 50xxx Mode
//# or Socket-Device (in this mode run Login Procedure first)
//######################################################################
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ScktComp;

type
  TForm1 = class(TForm)
    gb_outputs: TGroupBox;
    gb_inputs: TGroupBox;
    gb_counter: TGroupBox;
    gb_setbit: TGroupBox;
    cb_output0: TCheckBox;
    cb_output1: TCheckBox;
    cb_output2: TCheckBox;
    cb_output3: TCheckBox;
    cb_output4: TCheckBox;
    cb_output5: TCheckBox;
    cb_output6: TCheckBox;
    cb_output7: TCheckBox;
    cb_output8: TCheckBox;
    cb_output9: TCheckBox;
    cb_output10: TCheckBox;
    cb_output11: TCheckBox;
    sh_input0: TShape;
    Label1: TLabel;
    sh_input1: TShape;
    label2: TLabel;
    sh_input2: TShape;
    sh_input: TLabel;
    sh_input3: TShape;
    Label4: TLabel;
    sh_input4: TShape;
    Label5: TLabel;
    sh_input5: TShape;
    Label6: TLabel;
    sh_input6: TShape;
    Label7: TLabel;
    sh_input7: TShape;
    Label8: TLabel;
    sh_input8: TShape;
    Label9: TLabel;
    sh_input9: TShape;
    Label10: TLabel;
    sh_input10: TShape;
    Label11: TLabel;
    sh_input11: TShape;
    Label12: TLabel;
    bt_read0: TButton;
    ed_counter0: TEdit;
    bt_clear0: TButton;
    bt_read1: TButton;
    ed_counter1: TEdit;
    bt_clear1: TButton;
    bt_read2: TButton;
    ed_counter2: TEdit;
    bt_clear2: TButton;
    bt_read3: TButton;
    ed_counter3: TEdit;
    bt_clear3: TButton;
    bt_read4: TButton;
    ed_counter4: TEdit;
    bt_clear4: TButton;
    bt_read5: TButton;
    ed_counter5: TEdit;
    bt_clear5: TButton;
    bt_read6: TButton;
    ed_counter6: TEdit;
    bt_clear6: TButton;
    bt_read7: TButton;
    ed_counter7: TEdit;
    bt_clear7: TButton;
    bt_read8: TButton;
    ed_counter8: TEdit;
    bt_clear8: TButton;
    bt_read9: TButton;
    ed_counter9: TEdit;
    bt_clear9: TButton;
    bt_read10: TButton;
    ed_counter10: TEdit;
    bt_clear10: TButton;
    bt_read11: TButton;
    ed_counter11: TEdit;
    bt_clear11: TButton;
    bt_registerrequest: TButton;
    bt_setbit: TButton;
    ed_setbits: TEdit;
    ed_value: TEdit;
    Label3: TLabel;
    gb_connection: TGroupBox;
    Label14: TLabel;
    ed_port: TEdit;
    bt_disconnect: TButton;
    StatusBar1: TStatusBar;
    cb_clearread: TCheckBox;
    bt_readall: TButton;
    bt_listen: TButton;
    ServerSocket1: TServerSocket;
    procedure bt_disconnectClick(Sender: TObject);
    procedure bt_registerrequestClick(Sender: TObject);
    procedure bt_setbitClick(Sender: TObject);
    procedure bt_readallClick(Sender: TObject);
    procedure bt_readClick(Sender: TObject);
    procedure bt_clearClick(Sender: TObject);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure cb_output0MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bt_listenClick(Sender: TObject);
    procedure ServerSocket1Listen(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1Accept(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

Type
  RReadRegister=packed record
    send_sequenz:word;
    rec_sequenz:word;
    sruct_type:word;
    length:word;
  end;

  RWriteRegister=packed record
    send_sequenz:word;
    rec_sequenz:word;
    sruct_type:word;
    length:word;
    word_anz:word;
    registers:word;
  end;

  RSetBits=packed record
    send_sequenz:word;
    rec_sequenz:word;
    sruct_type:word;
    length:word;
    set_bits:word;
    value:word;
  end ;

  RSendMode=packed record
    send_sequenz:word;
    rec_sequenz:word;
    sruct_type:word;
    length:word;
    EA_bits:word;
    intervall:word;
  end ;

  RRegState=packed record
    send_sequenz:word;
    rec_sequenz:word;
    sruct_type:word;
    length:word;
    driver_id : word;
    input_reg : word;
    output_reg : word;
  end;

  RReadCounter=packed record
    send_sequenz:word;
    rec_sequenz:word;
    sruct_type:word;
    length:word;
    counter_index : word;
  end;

  RClearCounter=packed record
    send_sequenz:word;
    rec_sequenz:word;
    sruct_type:word;
    length:word;
    counter_index : word;
  end;

  RCounter=packed record
    send_sequenz:word;
    rec_sequenz:word;
    sruct_type:word;
    length:word;
    counter_index: word;
    counter_value: longword;
  end;

  RAllCounter=packed record
    send_sequenz:word;
    rec_sequenz:word;
    sruct_type:word;
    length:word;
    counter_count: word;
    counter_value: array [0..11]of longword;
  end;

const
  BITSET : array [0..12] of word =
      ( 1, 2, 4, 8, 16, 32,  64, 128, 256, 512, 1024, 2048, 4096);
const
  INPUT_ON = cllime;
  INPUT_OFF = clgreen;

const
  TYP_READ_RGISTER = $0001;
  TYP_WRITE_REGISTER = $0008;
  TYP_SET_BIT = $0009;
  TYP_SEND_MODE = $0010;
  TYP_REGISTER_REQUEST = $0021;
  TYP_REGISTER_STATE = $0031;
  TYP_READ_COUNTER = $00B0;
  TYP_READ_CLEAR_COUNTER = $00C0;
  TYP_READ_ALL_COUNTER = $00B1;
  TYP_READ_CLEAR_ALL_COUNTER = $00C1;
  TYP_CLEAR_COUNTER = $00B2;
  TYP_COUNTER = $00B4;
  TYP_ALL_COUNTER = $00B5;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//*** Function for converting HexString to Integer/Word Value
function HexToInt(HexString : String) : Word;
var vin_CharCount           : integer;
    vwo_HexCharValue        : Word;
    vwo_HexValue            : Word;
begin
   vwo_HexValue := 0;
   HexString := UpperCase(HexString);
   for vin_CharCount := 1 to length(HexString) do
   begin
     vwo_HexCharValue := ord(HexString[vin_CharCount]);
     if vwo_HexCharValue > 57 then
        vwo_HexCharValue := vwo_HexCharValue - 55
     else
        vwo_HexCharValue := vwo_HexCharValue - 48;
     vwo_HexCharValue := vwo_HexCharValue shl ((length(HexString) - vin_CharCount) *  4);
     vwo_HexValue := vwo_HexValue or vwo_HexCharValue;
   end;
   HexToInt := vwo_HexValue;
end;

// ** Start server listening
procedure TForm1.bt_listenClick(Sender: TObject);
begin
  If ed_Port.Text <> '' Then
  begin
    ServerSocket1.Port := strtoint(ed_port.Text);
    ServerSocket1.Open;
  end
  Else ShowMessage ('No local port!');
end;

// ** on server start listening
procedure TForm1.ServerSocket1Listen(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  bt_listen.Enabled := false;
  bt_disconnect.Enabled := true;
  statusbar1.SimpleText := 'listening for client access';
end;

// ** on server accept connection
procedure TForm1.ServerSocket1Accept(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  gb_outputs.Enabled := true;
  gb_inputs.Enabled := true;
  gb_counter.Enabled := true;
  gb_setbit.Enabled := true;
  bt_registerrequest.Enabled := true;
  bt_readall.Enabled := true;
  Statusbar1. SimpleText := 'connected to ' + Socket.RemoteAddress;
//*** send registerrequest and readallcounter structure after connecting
  bt_registerrequest.onClick(self);
  sleep(50);
  bt_readall.onClick(self);
end;

// ** if connection closed
procedure TForm1.ServerSocket1ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  gb_outputs.Enabled := false;
  gb_inputs.Enabled := false;
  gb_counter.Enabled := false;
  gb_setbit.Enabled := false;
  bt_registerrequest.Enabled := false;
  bt_readall.Enabled := false;
  ServerSocket1.Open;
  statusbar1.SimpleText := 'listening for client access';
end;

//*** Stop Server
procedure TForm1.bt_disconnectClick(Sender: TObject);
begin
  ServerSocket1.Close;
  bt_listen.Enabled := true;
  bt_disconnect.Enabled := false;
  Statusbar1.SimpleText := 'server stoped';
end;

//*** Procedure runs after receipt of data
procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var dummycount : integer;
  PReadRegister    : ^RReadRegister;
  PWriteRegister   : ^RWriteRegister;
  PRegState        : ^RRegState;
  PCounter         : ^Rcounter;
  PAllCounter      : ^RAllCounter;
  databuffer      : array[0..100] of Byte;
begin
//*** write received data to buffer
  Socket.ReceiveBuf(databuffer,Socket.ReceiveLength);
//*** recognize which structure was received
  PReadRegister := @databuffer;
  case PReadRegister^.sruct_type of
  TYP_WRITE_REGISTER : begin;
                         PWriteRegister := @databuffer;
                         for dummycount := 0 to 11 do
                         begin
                           if PWriteRegister^.registers and BITSET[dummycount] = BITSET[dummycount] then
                             (FindComponent( 'sh_input' + IntToStr( dummycount ))as tshape).brush.color := INPUT_ON
                           else
                             (FindComponent( 'sh_input' + IntToStr( dummycount ))as tshape).brush.color := INPUT_OFF
                         end;
                       end;
   TYP_REGISTER_STATE: begin;
                         PRegState := @databuffer;
                         for dummycount := 0 to 11 do
                         begin
                           if PRegState^.input_reg and BITSET[dummycount] = BITSET[dummycount] then
                             (FindComponent( 'sh_input' + IntToStr( dummycount ))as tshape).brush.color := INPUT_ON
                           else
                             (FindComponent( 'sh_input' + IntToStr( dummycount ))as tshape).brush.color := INPUT_OFF
                         end;
                         for dummycount := 0 to 11 do
                         begin
                           if PRegState^.output_reg and BITSET[dummycount] = BITSET[dummycount] then
                             (FindComponent( 'cb_output' + IntToStr( dummycount ))as tcheckbox).checked := True
                           else
                             (FindComponent( 'cb_output' + IntToStr( dummycount ))as tcheckbox).checked := False;
                         end;
                       end;
         TYP_COUNTER : begin
                         PCounter := @databuffer;
                         (FindComponent( 'ed_counter' + inttostr(PCounter^.counter_index) ) as Tedit).text := inttostr(Pcounter^.counter_value);
                       end;
     TYP_ALL_COUNTER : begin
                         PallCounter := @databuffer;
                         for dummycount := 0 to 11 do
                           (FindComponent( 'ed_counter' + inttostr(dummycount) ) as Tedit).text := inttostr(PAllCounter^.counter_value[dummycount]);
                       end;
  end;
end;

//*** inputs and outputs will be refreshed by using RegisterRequest structure
procedure TForm1.bt_registerrequestClick(Sender: TObject);
var RegRequest : RReadRegister;
begin
  RegRequest.send_sequenz := 0;
  RegRequest.rec_sequenz := 0;
  RegRequest.sruct_type := TYP_REGISTER_REQUEST;
  RegRequest.length := 8;
  ServerSocket1.Socket.Connections[0].SendBuf(RegRequest, RegRequest.length);
end;

//*** set outputs by using Writeregister structure
procedure TForm1.cb_output0MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  outputbitcounter : byte;
  Writeregister :RWriteRegister;
begin
  WriteRegister.send_sequenz := 0;
  WriteRegister.rec_sequenz := 0;
  WriteRegister.sruct_type := TYP_WRITE_REGISTER;
  WriteRegister.length := 12;
  WriteRegister.word_anz := 1;
  WriteRegister.registers := 0;
  for outputbitcounter := 0 to 11 do
  begin
    If (FindComponent( 'cb_output' + inttostr(outputbitcounter))as tcheckbox).checked then
       WriteRegister.registers := WriteRegister.registers + BITSET[outputbitcounter];
  end;
  ServerSocket1.socket.Connections[0].SendBuf(WriteRegister,WriteRegister.length);
//*** refresh inputs and outputs in the form
  sleep(50);
  bt_registerrequest.onClick(self);
end;

//*** set outputs by using SetBits structure
procedure TForm1.bt_setbitClick(Sender: TObject);
var SetBit : RSetBits;
begin
  SetBit.send_sequenz := 0;
  SetBit.rec_sequenz := 0;
  SetBit.sruct_type := TYP_SET_BIT;
  SetBit.length := 12;
  SetBit.set_bits := hextoint(ed_setbits.Text);
  SetBit.value := hextoint(ed_value.Text);
  ServerSocket1.Socket.Connections[0].SendBuf(SetBit, SetBit.length);
  sleep(50);
  bt_registerrequest.onClick(self);
end;

//** read all Counter
procedure TForm1.bt_readallClick(Sender: TObject);
var ReadAllCounter : RReadRegister;
begin
  ReadAllCounter.send_sequenz := 0;
  ReadAllCounter.rec_sequenz := 0;
  if cb_clearread.checked then
    ReadAllCounter.sruct_type := TYP_READ_CLEAR_ALL_COUNTER
  else
    ReadAllCounter.sruct_type := TYP_READ_ALL_COUNTER;
  ReadAllCounter.length := 8;
  ServerSocket1.Socket.Connections[0].SendBuf(ReadAllCounter, ReadAllCounter.length);
end;

//** read Counter
procedure TForm1.bt_readClick(Sender: TObject);
var
  outputbitcounter : byte;
  ReadCounter :RReadCounter;
begin
  ReadCounter.send_sequenz := 0;
  ReadCounter.rec_sequenz := 0;
  if cb_clearread.checked then
    ReadCounter.sruct_type := TYP_READ_CLEAR_COUNTER // required firmware 2.05
  else
    ReadCounter.sruct_type := TYP_READ_COUNTER;
  ReadCounter.length := 10;
//** find out which button was clicked
  for outputbitcounter := 0 to 11 do
  begin
    If Sender = (FindComponent( 'bt_read' + inttostr(outputbitcounter))) then
       ReadCounter.counter_index := outputbitcounter;
  end;
  ServerSocket1.socket.Connections[0].SendBuf(ReadCounter,ReadCounter.length);
end;

// ** clear counter
procedure TForm1.bt_clearClick(Sender: TObject);
var
  outputbitcounter : byte;
  ReadCounter :RReadCounter;
begin
  ReadCounter.send_sequenz := 0;
  ReadCounter.rec_sequenz := 0;
  ReadCounter.sruct_type := TYP_CLEAR_COUNTER;
  ReadCounter.length := 10;
//** find out which button was clicked
  for outputbitcounter := 0 to 11 do
  begin
    If Sender = (FindComponent( 'bt_clear' + inttostr(outputbitcounter))) then
       ReadCounter.counter_index := outputbitcounter;
  end;
  ServerSocket1.socket.Connections[0].SendBuf(ReadCounter,ReadCounter.length);
end;

// ** Error handling
procedure TForm1.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  errorcode := 0;
  showmessage('Connection Error');
end;

end.
