// io_peerDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "io_peer.h"
#include "io_peerDlg.h"
#include "mysocket.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//definition of READ REGISTER struct
typedef struct _READREG
{
	
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_typ;
	WORD length;

} READREG;

//definition of WRITE REGISTER struct
typedef struct _WRITEREG
{
	
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_typ;
	WORD length;

	struct _WRITE_REG
	{
		WORD word_anz;
		WORD registers[];
	
	} WRITE_REG;

} WRITEREG;

//definition of SET BIT struct
typedef struct _SETBIT
{
	
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_typ;
	WORD length;

	struct _SET_BIT
	{
		WORD set_bits;
		WORD value;
	
	} SET_BIT;

} SETBIT;

//definition of REGISTER REQUEST struct
typedef struct _REGREQUEST
{
	
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_typ;
	WORD length;

} REGREQUEST;

//definition of REGISTER STATE struct
typedef struct _REGSTATE
{
	
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_typ;
	WORD length;

	struct _REG_STATE
	{
		WORD Driver_id;
		WORD INPUT_REG;
		WORD OUTPUT_REG;
	
	} REG_STATE;

} REGSTATE;

//definition of SEND MODE struct
typedef struct _SENDMODE
{
	
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_typ;
	WORD length;

	struct _SEND_MODE
	{
		WORD EA_bits;
		WORD intervall;
	
	} SEND_MODE;

} SENDMODE;

//definition of READ COUNTER struct
typedef struct _READCOUNTER
{
	
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_typ;
	WORD length;

	struct _READ_COUNTER
	{
		WORD counter_index;
	
	} READ_COUNTER;

} READCOUNTER;

//definition of COUNTER struct
typedef struct _COUNTER
{
	
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_typ;
	WORD length;

	struct _COUNT_ER
	{
		WORD counter_index;
		long counter_value;
	
	} COUNT_ER;

} COUNTER;

//definition of READ ALL COUNTER struct
typedef struct _READALLCOUNTER
{
	
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_typ;
	WORD length;

} READALLCOUNTER;

//definition of ALL COUNTER struct
typedef struct _ALLCOUNTER
{
	
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_typ;
	WORD length;

	struct _ALL_COUNTER
	{
		WORD counter_count;
		long counter_value[12];
	
	} ALL_COUNTER;

} ALLCOUNTER;

//definition of CLEAR COUNTER struct
typedef struct _CLEARCOUNTER
{
	
	WORD send_sequence;
	WORD rec_sequence;
	WORD struct_typ;
	WORD length;

	struct _CLEAR_COUNTER
	{
		WORD counter_index;

	} CLEAR_COUNTER;

} CLEARCOUNTER;


//declaration of socket
CMySocket g_MySocket, g_SecondSocket;

//global varialbes 4 every struct
CLEARCOUNTER g_sclearcounter;
ALLCOUNTER g_sallcounter;
COUNTER g_scounter;
READALLCOUNTER g_sreadallcounter;
READCOUNTER g_sreadcounter;
READREG g_sreadreg;	
REGREQUEST g_sregrequest;
REGSTATE g_sregstate;
SENDMODE g_ssendmode;
SETBIT g_ssetbit;
WRITEREG g_swritereg;


//automaticly generated classes
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

////////////////////////////////////////////////////////////////////////////
CIo_peerDlg::CIo_peerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIo_peerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIo_peerDlg)
	m_bout0 = FALSE;
	m_bout1 = FALSE;
	m_bout10 = FALSE;
	m_bout11 = FALSE;
	m_bout2 = FALSE;
	m_bout4 = FALSE;
	m_bout3 = FALSE;
	m_bout5 = FALSE;
	m_bout6 = FALSE;
	m_bout7 = FALSE;
	m_bout8 = FALSE;
	m_bout9 = FALSE;
	m_bin0 = FALSE;
	m_bin1 = FALSE;
	m_bin10 = FALSE;
	m_bin11 = FALSE;
	m_bin2 = FALSE;
	m_bin3 = FALSE;
	m_bin4 = FALSE;
	m_bin5 = FALSE;
	m_bin6 = FALSE;
	m_bin7 = FALSE;
	m_bin8 = FALSE;
	m_bin9 = FALSE;
	m_Value = _T("");
	m_SetBits = _T("");
	m_LocalPort = _T("");
	m_Counter1 = 0;
	m_Counter10 = 0;
	m_Counter11 = 0;
	m_Counter2 = 0;
	m_Counter3 = 0;
	m_Counter4 = 0;
	m_Counter5 = 0;
	m_Counter6 = 0;
	m_Counter7 = 0;
	m_Counter8 = 0;
	m_Counter9 = 0;
	m_Counter0 = 0;
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CIo_peerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIo_peerDlg)
	DDX_Check(pDX, IDC_OUTPUT0, m_bout0);
	DDX_Check(pDX, IDC_OUTPUT1, m_bout1);
	DDX_Check(pDX, IDC_OUTPUT10, m_bout10);
	DDX_Check(pDX, IDC_OUTPUT11, m_bout11);
	DDX_Check(pDX, IDC_OUTPUT2, m_bout2);
	DDX_Check(pDX, IDC_OUTPUT4, m_bout4);
	DDX_Check(pDX, IDC_OUTPUT3, m_bout3);
	DDX_Check(pDX, IDC_OUTPUT5, m_bout5);
	DDX_Check(pDX, IDC_OUTPUT6, m_bout6);
	DDX_Check(pDX, IDC_OUTPUT7, m_bout7);
	DDX_Check(pDX, IDC_OUTPUT8, m_bout8);
	DDX_Check(pDX, IDC_OUTPUT9, m_bout9);
	DDX_Check(pDX, IDC_INPUT0, m_bin0);
	DDX_Check(pDX, IDC_INPUT1, m_bin1);
	DDX_Check(pDX, IDC_INPUT10, m_bin10);
	DDX_Check(pDX, IDC_INPUT11, m_bin11);
	DDX_Check(pDX, IDC_INPUT2, m_bin2);
	DDX_Check(pDX, IDC_INPUT3, m_bin3);
	DDX_Check(pDX, IDC_INPUT4, m_bin4);
	DDX_Check(pDX, IDC_INPUT5, m_bin5);
	DDX_Check(pDX, IDC_INPUT6, m_bin6);
	DDX_Check(pDX, IDC_INPUT7, m_bin7);
	DDX_Check(pDX, IDC_INPUT8, m_bin8);
	DDX_Check(pDX, IDC_INPUT9, m_bin9);
	DDX_Text(pDX, IDC_VALUE, m_Value);
	DDX_Text(pDX, IDC_SETBITS, m_SetBits);
	DDX_Text(pDX, IDC_LOCALPORT, m_LocalPort);
	DDX_Text(pDX, IDC_COUNTER1, m_Counter1);
	DDX_Text(pDX, IDC_COUNTER10, m_Counter10);
	DDX_Text(pDX, IDC_COUNTER11, m_Counter11);
	DDX_Text(pDX, IDC_COUNTER2, m_Counter2);
	DDX_Text(pDX, IDC_COUNTER3, m_Counter3);
	DDX_Text(pDX, IDC_COUNTER4, m_Counter4);
	DDX_Text(pDX, IDC_COUNTER5, m_Counter5);
	DDX_Text(pDX, IDC_COUNTER6, m_Counter6);
	DDX_Text(pDX, IDC_COUNTER7, m_Counter7);
	DDX_Text(pDX, IDC_COUNTER8, m_Counter8);
	DDX_Text(pDX, IDC_COUNTER9, m_Counter9);
	DDX_Text(pDX, IDC_COUNTER0, m_Counter0);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CIo_peerDlg, CDialog)
	//{{AFX_MSG_MAP(CIo_peerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_BN_CLICKED(IDC_OUTPUT0, OnOutput0)
	ON_BN_CLICKED(IDC_OUTPUT1, OnOutput1)
	ON_BN_CLICKED(IDC_OUTPUT2, OnOutput2)
	ON_BN_CLICKED(IDC_OUTPUT3, OnOutput3)
	ON_BN_CLICKED(IDC_OUTPUT4, OnOutput4)
	ON_BN_CLICKED(IDC_OUTPUT5, OnOutput5)
	ON_BN_CLICKED(IDC_OUTPUT6, OnOutput6)
	ON_BN_CLICKED(IDC_OUTPUT7, OnOutput7)
	ON_BN_CLICKED(IDC_OUTPUT8, OnOutput8)
	ON_BN_CLICKED(IDC_OUTPUT9, OnOutput9)
	ON_BN_CLICKED(IDC_OUTPUT10, OnOutput10)
	ON_BN_CLICKED(IDC_OUTPUT11, OnOutput11)
	ON_EN_CHANGE(IDC_SETBITS, OnChangeSetbits)
	ON_EN_CHANGE(IDC_VALUE, OnChangeValue)
	ON_BN_CLICKED(IDC_BIND, OnBind)
	ON_BN_CLICKED(IDC_BSETBIT, OnBsetbit)
	ON_EN_CHANGE(IDC_LOCALPORT, OnChangeLocalport)
	ON_BN_CLICKED(IDC_REGREQ, OnRegreq)
	ON_BN_CLICKED(IDC_READCOUNTER0, OnReadcounter0)
	ON_BN_CLICKED(IDC_READCOUNTER1, OnReadcounter1)
	ON_BN_CLICKED(IDC_READCOUNTER2, OnReadcounter2)
	ON_BN_CLICKED(IDC_READCOUNTER3, OnReadcounter3)
	ON_BN_CLICKED(IDC_READCOUNTER4, OnReadcounter4)
	ON_BN_CLICKED(IDC_READCOUNTER5, OnReadcounter5)
	ON_BN_CLICKED(IDC_READCOUNTER6, OnReadcounter6)
	ON_BN_CLICKED(IDC_READCOUNTER7, OnReadcounter7)
	ON_BN_CLICKED(IDC_READCOUNTER8, OnReadcounter8)
	ON_BN_CLICKED(IDC_READCOUNTER9, OnReadcounter9)
	ON_BN_CLICKED(IDC_READCOUNTER10, OnReadcounter10)
	ON_BN_CLICKED(IDC_READCOUNTER11, OnReadcounter11)
	ON_BN_CLICKED(IDC_CLEARCOUNTER0, OnClearcounter0)
	ON_BN_CLICKED(IDC_CLEARCOUNTER1, OnClearcounter1)
	ON_BN_CLICKED(IDC_CLEARCOUNTER2, OnClearcounter2)
	ON_BN_CLICKED(IDC_CLEARCOUNTER3, OnClearcounter3)
	ON_BN_CLICKED(IDC_CLEARCOUNTER4, OnClearcounter4)
	ON_BN_CLICKED(IDC_CLEARCOUNTER5, OnClearcounter5)
	ON_BN_CLICKED(IDC_CLEARCOUNTER6, OnClearcounter6)
	ON_BN_CLICKED(IDC_CLEARCOUNTER7, OnClearcounter7)
	ON_BN_CLICKED(IDC_CLEARCOUNTER8, OnClearcounter8)
	ON_BN_CLICKED(IDC_CLEARCOUNTER9, OnClearcounter9)
	ON_BN_CLICKED(IDC_CLEARCOUNTER10, OnClearcounter10)
	ON_BN_CLICKED(IDC_CLEARCOUNTER11, OnClearcounter11)
	ON_BN_CLICKED(IDC_READALLCOUNTER, OnReadallcounter)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////


//dialog initialisation function
BOOL CIo_peerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	SetIcon(m_hIcon, TRUE);		
	SetIcon(m_hIcon, FALSE);	
	
	// aditional initialisation

	//initializing pointer on dialog
	g_MySocket.m_pDialog=this;
	g_SecondSocket.m_pDialog=this;

	//initializing structure-variables
	g_sreadreg.send_sequence=0;
	g_sreadreg.rec_sequence=0;
	g_sreadreg.struct_typ=0x0001;
	g_sreadreg.length=8;

	g_swritereg.send_sequence=0;
	g_swritereg.rec_sequence=0;
	g_swritereg.struct_typ=0x0008;
	g_swritereg.length=12;

	g_ssetbit.send_sequence=0;
	g_ssetbit.rec_sequence=0;
	g_ssetbit.struct_typ=0x0009;
	g_ssetbit.length=12;

	g_sregrequest.send_sequence=0;
	g_sregrequest.rec_sequence=0;
	g_sregrequest.struct_typ=0x0021;
	g_sregrequest.length=8;

	g_sregstate.send_sequence=0;
	g_sregstate.rec_sequence=0;
	g_sregstate.struct_typ=0x0031;
	g_sregstate.length=14;

	g_ssendmode.send_sequence=0;
	g_ssendmode.rec_sequence=0;
	g_ssendmode.struct_typ=0x0010;
	g_ssendmode.length=12;

	g_sreadcounter.send_sequence=0;
	g_sreadcounter.rec_sequence=0;
	g_sreadcounter.struct_typ=0x00B0;
	g_sreadcounter.length=10;

	g_scounter.send_sequence=0;
	g_scounter.rec_sequence=0;
	g_scounter.struct_typ=0x00B4;
	g_scounter.length=14;

	g_sreadallcounter.send_sequence=0;
	g_sreadallcounter.rec_sequence=0;
	g_sreadallcounter.struct_typ=0x00B1;
	g_sreadallcounter.length=8;

	g_sallcounter.send_sequence=0;
	g_sallcounter.rec_sequence=0;
	g_sallcounter.struct_typ=0x00B5;
	g_sallcounter.length=58;

	g_sclearcounter.send_sequence=0;
	g_sclearcounter.rec_sequence=0;
	g_sclearcounter.struct_typ=0x00B2;
	g_sclearcounter.length=10;

	//initializing port edit-field with common web-IO udp port
	m_LocalPort="49153";
	//initialising SetBit and Value edit-field variables
	m_SetBits="0F0";
	m_Value="FFF";

	UpdateData(FALSE);

	// disable/enable certain buttons
	GetDlgItem(IDC_DISCONNECT)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER0)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER1)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER2)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER3)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER4)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER5)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER6)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER7)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER8)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER9)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER10)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER11)->EnableWindow(FALSE);
	
	return TRUE; 
}


//automatically generated stuff again
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

void CIo_peerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CIo_peerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); 

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CIo_peerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////


//Bind button
void CIo_peerDlg::OnBind() 
{
	UpdateData(TRUE);
	//catch user errors
	if (m_LocalPort!="")
		{
			//create and connect socket
			g_MySocket.Create(atoi(m_LocalPort));

			if (g_MySocket.Listen())
			{
				MessageBox("Socket listening.");
				//call the 2 buttons to refresh screen-information
							
				// diable/enable certain buttons
				GetDlgItem(IDC_BIND)->EnableWindow(FALSE);
				GetDlgItem(IDC_DISCONNECT)->EnableWindow(TRUE);
				GetDlgItem(IDC_LOCALPORT)->EnableWindow(FALSE);

				GetDlgItem(IDC_CLEARCOUNTER0)->EnableWindow(TRUE);
				GetDlgItem(IDC_CLEARCOUNTER1)->EnableWindow(TRUE);
				GetDlgItem(IDC_CLEARCOUNTER2)->EnableWindow(TRUE);
				GetDlgItem(IDC_CLEARCOUNTER3)->EnableWindow(TRUE);
				GetDlgItem(IDC_CLEARCOUNTER4)->EnableWindow(TRUE);
				GetDlgItem(IDC_CLEARCOUNTER5)->EnableWindow(TRUE);
				GetDlgItem(IDC_CLEARCOUNTER6)->EnableWindow(TRUE);
				GetDlgItem(IDC_CLEARCOUNTER7)->EnableWindow(TRUE);
				GetDlgItem(IDC_CLEARCOUNTER8)->EnableWindow(TRUE);
				GetDlgItem(IDC_CLEARCOUNTER9)->EnableWindow(TRUE);
				GetDlgItem(IDC_CLEARCOUNTER10)->EnableWindow(TRUE);
				GetDlgItem(IDC_CLEARCOUNTER11)->EnableWindow(TRUE);
			}

		}
	else
		MessageBox("You need a Port..");
	
}

//update variables on change of localport edit field
void CIo_peerDlg::OnChangeLocalport() 
{
	UpdateData(TRUE);	
}

//close "connection" in case of program shutdown
void CIo_peerDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	//close sockets
	g_MySocket.Close();
	g_SecondSocket.Close();
}

//Disconnect Button
void CIo_peerDlg::OnDisconnect() 
{
	//close sockets
	g_MySocket.Close();
	g_SecondSocket.Close();
	// diable/enable certain buttons
	GetDlgItem(IDC_BIND)->EnableWindow(TRUE);
	GetDlgItem(IDC_DISCONNECT)->EnableWindow(FALSE);
	GetDlgItem(IDC_LOCALPORT)->EnableWindow(TRUE);

	GetDlgItem(IDC_CLEARCOUNTER0)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER1)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER2)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER3)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER4)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER5)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER6)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER7)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER8)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER9)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER10)->EnableWindow(FALSE);
	GetDlgItem(IDC_CLEARCOUNTER11)->EnableWindow(FALSE);
}


//one function 4 all output checkboxes
//sends the changes made on the dialog to web-IO device
void CIo_peerDlg::OnOutput(int index, bool status)
{

	if (status==TRUE)
	{
		g_ssetbit.SET_BIT.set_bits=pow(2,index);
		g_ssetbit.SET_BIT.value=pow(2,index);

		g_SecondSocket.Send(&g_ssetbit,g_ssetbit.length);
	}
	else
	{
		g_ssetbit.SET_BIT.set_bits=pow(2,index);
		g_ssetbit.SET_BIT.value=4095-pow(2,index);

		g_SecondSocket.Send(&g_ssetbit,g_ssetbit.length);
	}
}


//every checkbox calls "OnOutput" on click transmitting
//the output's index and curent status
void CIo_peerDlg::OnOutput0() 
{
	UpdateData(TRUE);
	OnOutput(0,m_bout0);
}

void CIo_peerDlg::OnOutput1() 
{
	UpdateData(TRUE);
	OnOutput(1,m_bout1);
}

void CIo_peerDlg::OnOutput2() 
{
	UpdateData(TRUE);
	OnOutput(2,m_bout2);
}

void CIo_peerDlg::OnOutput3() 
{
	UpdateData(TRUE);
	OnOutput(3,m_bout3);	
}

void CIo_peerDlg::OnOutput4() 
{
	UpdateData(TRUE);
	OnOutput(4,m_bout4);	
}

void CIo_peerDlg::OnOutput5() 
{
	UpdateData(TRUE);
	OnOutput(5,m_bout5);	
}

void CIo_peerDlg::OnOutput6() 
{
	UpdateData(TRUE);
	OnOutput(6,m_bout6);	
}

void CIo_peerDlg::OnOutput7() 
{
	UpdateData(TRUE);
	OnOutput(7,m_bout7);	
}

void CIo_peerDlg::OnOutput8() 
{
	UpdateData(TRUE);
	OnOutput(8,m_bout8);	
}

void CIo_peerDlg::OnOutput9() 
{
	UpdateData(TRUE);
	OnOutput(9,m_bout9);	
}

void CIo_peerDlg::OnOutput10() 
{
	UpdateData(TRUE);
	OnOutput(10,m_bout10);	
}

void CIo_peerDlg::OnOutput11() 
{
	UpdateData(TRUE);
	OnOutput(11,m_bout11);	
}


//OnReceive function is called by socket, when data is arriving
void CIo_peerDlg::OnReceive()
{
		int recieved;	//value of data
		//dynamic buffer with maximum size of web-IO transmission capability
		WORD* pBuffer =new WORD[256];
	
		//recieve method returning transmission value  
		recieved=g_SecondSocket.Receive(pBuffer,256);

		//catch errors
		if (recieved==SOCKET_ERROR)
			MessageBox("Socket Error");
		else
		{
			//what kind of package have we here??
			//3rd word in the received buffer contains the structure ID (status_typ)
			switch (pBuffer[2])
			{
			//a WRITE REGISTER struct
			case 0x0008: 
				{
					for (int i=1; i<=pBuffer[4]; i++) SetInput(pBuffer[4+i]);	
				}
				break;
			case 0x0031:
				{
					SetInput(pBuffer[5]);
					SetOutput(pBuffer[6]);
				}
				break;
			case 0x00B4:
				{
					SetCounter(pBuffer[4],pBuffer[5]);
				}
				break;
			case 0x00B5:
				{
					for (int i=0; i<=11; i++) SetCounter(i,pBuffer[5+2*i]);
				}
				break;
			}
		}
		//release buffer
		delete[] pBuffer;
}

//one function to set all input-checkboxes
void CIo_peerDlg::SetInput(WORD reg)
{
	//sets every input by bitwise AND  
	if (reg & 1)    m_bin0=TRUE;  else m_bin0=FALSE;
	if (reg & 2)    m_bin1=TRUE;  else m_bin1=FALSE;
	if (reg & 4)    m_bin2=TRUE;  else m_bin2=FALSE;
	if (reg & 8)    m_bin3=TRUE;  else m_bin3=FALSE;
	if (reg & 16)   m_bin4=TRUE;  else m_bin4=FALSE;
	if (reg & 32)   m_bin5=TRUE;  else m_bin5=FALSE;
	if (reg & 64)   m_bin6=TRUE;  else m_bin6=FALSE;
	if (reg & 128)  m_bin7=TRUE;  else m_bin7=FALSE;
	if (reg & 256)  m_bin8=TRUE;  else m_bin8=FALSE;
	if (reg & 512)  m_bin9=TRUE;  else m_bin9=FALSE;
	if (reg & 1024) m_bin10=TRUE; else m_bin10=FALSE;
	if (reg & 2048) m_bin11=TRUE; else m_bin11=FALSE;
	
	UpdateData(FALSE);
}

//one function to set all output-checkboxes
void CIo_peerDlg::SetOutput(WORD reg)
{
	//sets every output by bitwise AND  
	if (reg & 1)    m_bout0=TRUE;  else m_bout0=FALSE;
	if (reg & 2)    m_bout1=TRUE;  else m_bout1=FALSE;
	if (reg & 4)    m_bout2=TRUE;  else m_bout2=FALSE;
	if (reg & 8)    m_bout3=TRUE;  else m_bout3=FALSE;
	if (reg & 16)   m_bout4=TRUE;  else m_bout4=FALSE;
	if (reg & 32)   m_bout5=TRUE;  else m_bout5=FALSE;
	if (reg & 64)   m_bout6=TRUE;  else m_bout6=FALSE;
	if (reg & 128)  m_bout7=TRUE;  else m_bout7=FALSE;
	if (reg & 256)  m_bout8=TRUE;  else m_bout8=FALSE;
	if (reg & 512)  m_bout9=TRUE;  else m_bout9=FALSE;
	if (reg & 1024) m_bout10=TRUE; else m_bout10=FALSE;
	if (reg & 2048) m_bout11=TRUE; else m_bout11=FALSE;
	
	UpdateData(FALSE);
}

void CIo_peerDlg::SetCounter(int index, int value)
{

	switch (index)
	{
	case 0: m_Counter0=value;
		break;
	case 1: m_Counter1=value;
		break;
	case 2: m_Counter2=value;
		break;
	case 3: m_Counter3=value;
		break;
	case 4: m_Counter4=value;
		break;
	case 5: m_Counter5=value;
		break;
	case 6: m_Counter6=value;
		break;
	case 7: m_Counter7=value;
		break;
	case 8: m_Counter8=value;
		break;
	case 9: m_Counter9=value;
		break;
	case 10: m_Counter10=value;
		break;
	case 11: m_Counter11=value;
		break;

	};
	UpdateData(FALSE);

}

//update variables on change of setbits edit field
void CIo_peerDlg::OnChangeSetbits() 
{
	UpdateData(TRUE);
}

//update variables on change of value edit field
void CIo_peerDlg::OnChangeValue() 
{
	UpdateData(TRUE);	
}


//use SET BIT structure to set outputs on web-IO
void CIo_peerDlg::OnBsetbit() 
{
	//convert String to unsigned long with base 16 (hex)
	g_ssetbit.SET_BIT.set_bits=strtoul(m_SetBits,0,16);
	g_ssetbit.SET_BIT.value=strtoul(m_Value,0,16);
	
	g_SecondSocket.Send(&g_ssetbit,g_ssetbit.length);	

}

//on buttonclick send a REGISTER REQUEST
void CIo_peerDlg::OnRegreq() 
{
	g_SecondSocket.Send(&g_sregrequest,g_sregrequest.length);
}




/////////////////////////////////////////////////////////////////
//every button sends a READ COUNTER struct with an suitable index

void CIo_peerDlg::OnReadcounter0() 
{
	g_sreadcounter.READ_COUNTER.counter_index=0;
	g_SecondSocket.Send(&g_sreadcounter,g_sreadcounter.length);
}
void CIo_peerDlg::OnReadcounter1() 
{
	g_sreadcounter.READ_COUNTER.counter_index=1;
	g_SecondSocket.Send(&g_sreadcounter,g_sreadcounter.length);	
}
void CIo_peerDlg::OnReadcounter2() 
{
	g_sreadcounter.READ_COUNTER.counter_index=2;
	g_SecondSocket.Send(&g_sreadcounter,g_sreadcounter.length);	
}
void CIo_peerDlg::OnReadcounter3() 
{
	g_sreadcounter.READ_COUNTER.counter_index=3;
	g_SecondSocket.Send(&g_sreadcounter,g_sreadcounter.length);	
}
void CIo_peerDlg::OnReadcounter4() 
{
	g_sreadcounter.READ_COUNTER.counter_index=4;
	g_SecondSocket.Send(&g_sreadcounter,g_sreadcounter.length);	
}
void CIo_peerDlg::OnReadcounter5() 
{
	g_sreadcounter.READ_COUNTER.counter_index=5;
	g_SecondSocket.Send(&g_sreadcounter,g_sreadcounter.length);	
}
void CIo_peerDlg::OnReadcounter6() 
{
	g_sreadcounter.READ_COUNTER.counter_index=6;
	g_SecondSocket.Send(&g_sreadcounter,g_sreadcounter.length);	
}
void CIo_peerDlg::OnReadcounter7() 
{
	g_sreadcounter.READ_COUNTER.counter_index=7;
	g_SecondSocket.Send(&g_sreadcounter,g_sreadcounter.length);	
}
void CIo_peerDlg::OnReadcounter8() 
{
	g_sreadcounter.READ_COUNTER.counter_index=8;
	g_SecondSocket.Send(&g_sreadcounter,g_sreadcounter.length);	
}
void CIo_peerDlg::OnReadcounter9() 
{
	g_sreadcounter.READ_COUNTER.counter_index=9;
	g_SecondSocket.Send(&g_sreadcounter,g_sreadcounter.length);	
}
void CIo_peerDlg::OnReadcounter10() 
{
	g_sreadcounter.READ_COUNTER.counter_index=10;
	g_SecondSocket.Send(&g_sreadcounter,g_sreadcounter.length);	
}
void CIo_peerDlg::OnReadcounter11() 
{
	g_sreadcounter.READ_COUNTER.counter_index=11;
	g_SecondSocket.Send(&g_sreadcounter,g_sreadcounter.length);	
}
////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////
//the clear button sets the corresponding editbox to zero
void CIo_peerDlg::OnClearcounter0() 
{
	g_sclearcounter.CLEAR_COUNTER.counter_index=0;
	g_SecondSocket.Send(&g_sclearcounter,g_sclearcounter.length);
	m_Counter0=0;
	UpdateData(FALSE);
}

void CIo_peerDlg::OnClearcounter1() 
{
	g_sclearcounter.CLEAR_COUNTER.counter_index=1;
	g_SecondSocket.Send(&g_sclearcounter,g_sclearcounter.length);
	m_Counter1=0;
	UpdateData(FALSE);	
}

void CIo_peerDlg::OnClearcounter2() 
{
	g_sclearcounter.CLEAR_COUNTER.counter_index=2;
	g_SecondSocket.Send(&g_sclearcounter,g_sclearcounter.length);
	m_Counter2=0;
	UpdateData(FALSE);	
}

void CIo_peerDlg::OnClearcounter3() 
{
	g_sclearcounter.CLEAR_COUNTER.counter_index=3;
	g_SecondSocket.Send(&g_sclearcounter,g_sclearcounter.length);
	m_Counter3=0;
	UpdateData(FALSE);	
}

void CIo_peerDlg::OnClearcounter4() 
{
	g_sclearcounter.CLEAR_COUNTER.counter_index=4;
	g_SecondSocket.Send(&g_sclearcounter,g_sclearcounter.length);
	m_Counter4=0;
	UpdateData(FALSE);	
}

void CIo_peerDlg::OnClearcounter5() 
{
	g_sclearcounter.CLEAR_COUNTER.counter_index=5;
	g_SecondSocket.Send(&g_sclearcounter,g_sclearcounter.length);
	m_Counter5=0;
	UpdateData(FALSE);	
}

void CIo_peerDlg::OnClearcounter6() 
{
	g_sclearcounter.CLEAR_COUNTER.counter_index=6;
	g_SecondSocket.Send(&g_sclearcounter,g_sclearcounter.length);
	m_Counter6=0;
	UpdateData(FALSE);	
}

void CIo_peerDlg::OnClearcounter7() 
{
	g_sclearcounter.CLEAR_COUNTER.counter_index=7;
	g_SecondSocket.Send(&g_sclearcounter,g_sclearcounter.length);
	m_Counter7=0;
	UpdateData(FALSE);	
}

void CIo_peerDlg::OnClearcounter8() 
{
	g_sclearcounter.CLEAR_COUNTER.counter_index=8;
	g_SecondSocket.Send(&g_sclearcounter,g_sclearcounter.length);
	m_Counter8=0;
	UpdateData(FALSE);	
}

void CIo_peerDlg::OnClearcounter9() 
{
	g_sclearcounter.CLEAR_COUNTER.counter_index=9;
	g_SecondSocket.Send(&g_sclearcounter,g_sclearcounter.length);
	m_Counter9=0;
	UpdateData(FALSE);	
}

void CIo_peerDlg::OnClearcounter10() 
{
	g_sclearcounter.CLEAR_COUNTER.counter_index=10;
	g_SecondSocket.Send(&g_sclearcounter,g_sclearcounter.length);
	m_Counter10=0;
	UpdateData(FALSE);	
}

void CIo_peerDlg::OnClearcounter11() 
{
	g_sclearcounter.CLEAR_COUNTER.counter_index=11;
	g_SecondSocket.Send(&g_sclearcounter,g_sclearcounter.length);
	m_Counter11=0;
	UpdateData(FALSE);	
}
/////////////////////////////////////////////////////////////////////////



//send the READ ALL COUNTER struct
void CIo_peerDlg::OnReadallcounter() 
{
	g_SecondSocket.Send(&g_sreadallcounter,g_sreadallcounter.length);
}


//function is called by socket, when client connects
void CIo_peerDlg::OnAccept()
{
	//IMPORTANT
	//close SecondSocket, maybe in Web-IO settings 'INAVTIVE TIMEOUT' is enabled
	//in this case die Web-IO closes the connection after a certain time of inactivity
	//and reconnects on next input-change. If then SecondSocket is still open, Program crashes
	g_SecondSocket.Close();
	//no SecondSocket.Create() nessecary, it's included in die Accept method
	if (g_MySocket.Accept(g_SecondSocket))
	{
		MessageBox("Client connected");
		//get some information from device
		OnRegreq();
		OnReadallcounter();
	}
	else
		MessageBox("Error OnAccept()");
}
