unit webioanalog_u1_v1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button10: TButton;
    ClientSocket1: TClientSocket;
    Memo1: TMemo;
    Button11: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure Button11Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  button :integer;
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  button:=1;
  button10.click;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  button:=2;
  button10.click;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  clientsocket1.address:=edit1.text;
  clientsocket1.active:=true;
end;

procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  if button=0 then clientsocket1.socket.sendtext('GET /Single')
  else
  clientsocket1.socket.sendtext('GET /Single'+inttostr(button));
end;

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  memo1.Lines.add(clientsocket1.socket.receivetext);
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
   memo1.Lines.Clear;
end;

end.
