/****************************************************************/
/* sockcpp.h													*/
/****************************************************************/
/* Klassendefinitionen:											*/
/*	- sockcpp (Basisfunktionen der WINSOCK-API)					*/
/*  - sockServerWnd (Aufruf der Funktion fr einen Server		*/
/*	  und Ausgabe von Statusmeldungen)							*/
/****************************************************************/

#define	ECHO_PORT	7
#define	MAX_SOCKETS	32
#define	BUFFER_SIZE	512					// maximale Paketgre COM-Server

class sockcpp 
    {
      public:
          sockcpp();					// Konstruktor
		  ~sockcpp();					// Destruktor der Klasse
		      int Accept       ( struct sockaddr_in *peer_in );
		      int Bind         ( u_short uPort = ECHO_PORT );  
              int GetClient    ( int iClient );
              int CheckMySocket( int iClient );

			  int HandleClient( void );
			 void CloseAllHandle ( void );
			 void Close ( int );
			  int Listen( void );
			  int RecvClient( int iClient, LPSTR pBuffer, int iLenBuf );
			 void SendClient( int iClient, LPSTR pBuffer, int iLenBuf );
		      int Socket    ( int af= AF_INET, int type=SOCK_STREAM,
							  int protocol=0 );
			  
      protected:
		   char  buffer[512];			// Receive Daten Buffer
        	int	 iMySock;				// Server Socket Handle
      private:
			int  iStatus;				// Rckgabewert der WINSOCK-Funktion
	     struct  sockaddr_in  addr;
         struct  timeval  seltime;		// Blocking Time fr select()
                 fd_set  readfds;
			int  in_use[MAX_SOCKETS];	// Client-Handle
     };

class sockServerWnd : public sockcpp 
    {
      public:
          sockServerWnd( HWND hWnd );	// Konstruktor
		 ~sockServerWnd();              // Destruktor der Klasse

		     int Init();				// Initialisiere Echo-Server
			void Action();				// Kontrolliere Connections
			void echo_server( int iClient );
			void accept_client();
			void ShowStatus( HWND hDlg, LPSTR lpMsg, int mWnd );

      protected:
      private:
		   HWND  hWndClass;				// Aktives Dialogfenster
		   char  szBuffer[128];			// Ausgabe von Statusmeldungen
		   char	 FAR* remoteIP;			// Client IP-Adresse anzeigen
    };
