unit WinForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.Net,
  System.Net.Sockets, System.IO, System.Text, System.Configuration ;

type
  TWinForm = class(System.Windows.Forms.Form)
  {$REGION 'Vom Designer verwalteter Code'}
  strict private
    /// <summary>
    /// Erforderliche Designervariable.
    /// </summary>
    components: System.ComponentModel.IContainer;
    gb_io: System.Windows.Forms.GroupBox;
    gb_connection: System.Windows.Forms.GroupBox;
    StatusBar1: System.Windows.Forms.StatusBar;
    cb_output0: System.Windows.Forms.CheckBox;
    cb_output1: System.Windows.Forms.CheckBox;
    cb_input0: System.Windows.Forms.CheckBox;
    cb_input1: System.Windows.Forms.CheckBox;
    lb_counter0: System.Windows.Forms.Label;
    lb_counter1: System.Windows.Forms.Label;
    ln_counterall: System.Windows.Forms.Label;
    bt_outputs_read: System.Windows.Forms.Button;
    bt_inputs_read: System.Windows.Forms.Button;
    tb_counter0: System.Windows.Forms.TextBox;
    tb_counter1: System.Windows.Forms.TextBox;
    bt_counter_read0: System.Windows.Forms.Button;
    bt_counter_read1: System.Windows.Forms.Button;
    bt_counter_readall: System.Windows.Forms.Button;
    bt_counter_clearall: System.Windows.Forms.Button;
    bt_counter_clear1: System.Windows.Forms.Button;
    bt_counter_clear0: System.Windows.Forms.Button;
    cb_output_polling: System.Windows.Forms.CheckBox;
    cb_input_polling: System.Windows.Forms.CheckBox;
    lb_interval: System.Windows.Forms.Label;
    tb_interval: System.Windows.Forms.TextBox;
    cb_counter_polling: System.Windows.Forms.CheckBox;
    lb_ip: System.Windows.Forms.Label;
    lb_port: System.Windows.Forms.Label;
    lb_password: System.Windows.Forms.Label;
    tb_ip: System.Windows.Forms.TextBox;
    tb_port: System.Windows.Forms.TextBox;
    tb_password: System.Windows.Forms.TextBox;
    bt_connect: System.Windows.Forms.Button;
    bt_disconnect: System.Windows.Forms.Button;
    timer_polling: System.Windows.Forms.Timer;
    /// <summary>
    /// Erforderliche Methode zur Untersttzung des Designers -
    /// ndern Sie die Methode nicht mit dem Quelltext-Editor
    /// </summary>
    procedure InitializeComponent;
    procedure bt_connect_Click(sender: System.Object; e: System.EventArgs);
    procedure cb_output0_MouseUp(sender: System.Object; e: System.Windows.Forms.MouseEventArgs);
    procedure cb_output1_MouseUp(sender: System.Object; e: System.Windows.Forms.MouseEventArgs);
    procedure bt_outputs_read_Click(sender: System.Object; e: System.EventArgs);
    procedure bt_inputs_read_Click(sender: System.Object; e: System.EventArgs);
    procedure bt_counter_read0_Click(sender: System.Object; e: System.EventArgs);
    procedure bt_counter_read1_Click(sender: System.Object; e: System.EventArgs);
    procedure bt_counter_readall_Click(sender: System.Object; e: System.EventArgs);
    procedure bt_counter_clear0_Click(sender: System.Object; e: System.EventArgs);
    procedure bt_counter_clear1_Click(sender: System.Object; e: System.EventArgs);
    procedure bt_counter_clearall_Click(sender: System.Object; e: System.EventArgs);
    procedure bt_disconnect_Click(sender: System.Object; e: System.EventArgs);
    procedure tb_interval_TextChanged(sender: System.Object; e: System.EventArgs);
    procedure timer_polling_Tick1(sender: System.Object; e: System.EventArgs);

  {$ENDREGION}
  strict protected
    /// <summary>
    /// Ressourcen nach der Verwendung bereinigen
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private-Deklarationen }
  public
    constructor Create;
    procedure callback_connect(ari : IAsyncResult);
    procedure callback_readdata(ari : IAsyncResult);
    procedure sendcommand(sendstring : String);
    procedure close();
  end;
    [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm))]

    implementation

{$AUTOBOX ON}

{$REGION 'Vom Windows Form-Designer erzeugter Code'}
/// <summary>
/// Erforderliche Methode zur Untersttzung des Designers --
/// ndern Sie die Methode nicht mit dem Quelltext-Editor
/// </summary>


procedure TWinForm.InitializeComponent;
begin
  Self.components := System.ComponentModel.Container.Create;
  Self.gb_io := System.Windows.Forms.GroupBox.Create;
  Self.cb_counter_polling := System.Windows.Forms.CheckBox.Create;
  Self.tb_interval := System.Windows.Forms.TextBox.Create;
  Self.lb_interval := System.Windows.Forms.Label.Create;
  Self.cb_input_polling := System.Windows.Forms.CheckBox.Create;
  Self.cb_output_polling := System.Windows.Forms.CheckBox.Create;
  Self.bt_counter_clearall := System.Windows.Forms.Button.Create;
  Self.bt_counter_clear1 := System.Windows.Forms.Button.Create;
  Self.bt_counter_clear0 := System.Windows.Forms.Button.Create;
  Self.bt_counter_readall := System.Windows.Forms.Button.Create;
  Self.bt_counter_read1 := System.Windows.Forms.Button.Create;
  Self.bt_counter_read0 := System.Windows.Forms.Button.Create;
  Self.tb_counter1 := System.Windows.Forms.TextBox.Create;
  Self.tb_counter0 := System.Windows.Forms.TextBox.Create;
  Self.bt_inputs_read := System.Windows.Forms.Button.Create;
  Self.bt_outputs_read := System.Windows.Forms.Button.Create;
  Self.ln_counterall := System.Windows.Forms.Label.Create;
  Self.lb_counter1 := System.Windows.Forms.Label.Create;
  Self.lb_counter0 := System.Windows.Forms.Label.Create;
  Self.cb_input1 := System.Windows.Forms.CheckBox.Create;
  Self.cb_input0 := System.Windows.Forms.CheckBox.Create;
  Self.cb_output1 := System.Windows.Forms.CheckBox.Create;
  Self.cb_output0 := System.Windows.Forms.CheckBox.Create;
  Self.gb_connection := System.Windows.Forms.GroupBox.Create;
  Self.bt_disconnect := System.Windows.Forms.Button.Create;
  Self.bt_connect := System.Windows.Forms.Button.Create;
  Self.tb_password := System.Windows.Forms.TextBox.Create;
  Self.tb_port := System.Windows.Forms.TextBox.Create;
  Self.tb_ip := System.Windows.Forms.TextBox.Create;
  Self.lb_password := System.Windows.Forms.Label.Create;
  Self.lb_port := System.Windows.Forms.Label.Create;
  Self.lb_ip := System.Windows.Forms.Label.Create;
  Self.StatusBar1 := System.Windows.Forms.StatusBar.Create;
  Self.timer_polling := System.Windows.Forms.Timer.Create(Self.components);
  Self.gb_io.SuspendLayout;
  Self.gb_connection.SuspendLayout;
  Self.SuspendLayout;
  // 
  // gb_io
  // 
  Self.gb_io.Controls.Add(Self.cb_counter_polling);
  Self.gb_io.Controls.Add(Self.tb_interval);
  Self.gb_io.Controls.Add(Self.lb_interval);
  Self.gb_io.Controls.Add(Self.cb_input_polling);
  Self.gb_io.Controls.Add(Self.cb_output_polling);
  Self.gb_io.Controls.Add(Self.bt_counter_clearall);
  Self.gb_io.Controls.Add(Self.bt_counter_clear1);
  Self.gb_io.Controls.Add(Self.bt_counter_clear0);
  Self.gb_io.Controls.Add(Self.bt_counter_readall);
  Self.gb_io.Controls.Add(Self.bt_counter_read1);
  Self.gb_io.Controls.Add(Self.bt_counter_read0);
  Self.gb_io.Controls.Add(Self.tb_counter1);
  Self.gb_io.Controls.Add(Self.tb_counter0);
  Self.gb_io.Controls.Add(Self.bt_inputs_read);
  Self.gb_io.Controls.Add(Self.bt_outputs_read);
  Self.gb_io.Controls.Add(Self.ln_counterall);
  Self.gb_io.Controls.Add(Self.lb_counter1);
  Self.gb_io.Controls.Add(Self.lb_counter0);
  Self.gb_io.Controls.Add(Self.cb_input1);
  Self.gb_io.Controls.Add(Self.cb_input0);
  Self.gb_io.Controls.Add(Self.cb_output1);
  Self.gb_io.Controls.Add(Self.cb_output0);
  Self.gb_io.Enabled := False;
  Self.gb_io.Location := System.Drawing.Point.Create(16, 16);
  Self.gb_io.Name := 'gb_io';
  Self.gb_io.Size := System.Drawing.Size.Create(440, 136);
  Self.gb_io.TabIndex := 0;
  Self.gb_io.TabStop := False;
  Self.gb_io.Text := 'Input/Output Control';
  // 
  // cb_counter_polling
  // 
  Self.cb_counter_polling.Location := System.Drawing.Point.Create(320, 104);
  Self.cb_counter_polling.Name := 'cb_counter_polling';
  Self.cb_counter_polling.Size := System.Drawing.Size.Create(64, 16);
  Self.cb_counter_polling.TabIndex := 21;
  Self.cb_counter_polling.Text := 'Polling';
  // 
  // tb_interval
  // 
  Self.tb_interval.Location := System.Drawing.Point.Create(240, 104);
  Self.tb_interval.Name := 'tb_interval';
  Self.tb_interval.Size := System.Drawing.Size.Create(72, 20);
  Self.tb_interval.TabIndex := 20;
  Self.tb_interval.Text := '250';
  Include(Self.tb_interval.TextChanged, Self.tb_interval_TextChanged);
  // 
  // lb_interval
  // 
  Self.lb_interval.Location := System.Drawing.Point.Create(176, 104);
  Self.lb_interval.Name := 'lb_interval';
  Self.lb_interval.Size := System.Drawing.Size.Create(64, 16);
  Self.lb_interval.TabIndex := 19;
  Self.lb_interval.Text := 'Interval';
  // 
  // cb_input_polling
  // 
  Self.cb_input_polling.Location := System.Drawing.Point.Create(96, 104);
  Self.cb_input_polling.Name := 'cb_input_polling';
  Self.cb_input_polling.Size := System.Drawing.Size.Create(64, 16);
  Self.cb_input_polling.TabIndex := 18;
  Self.cb_input_polling.Text := 'Polling';
  // 
  // cb_output_polling
  // 
  Self.cb_output_polling.Location := System.Drawing.Point.Create(16, 104);
  Self.cb_output_polling.Name := 'cb_output_polling';
  Self.cb_output_polling.Size := System.Drawing.Size.Create(64, 16);
  Self.cb_output_polling.TabIndex := 17;
  Self.cb_output_polling.Text := 'Polling';
  // 
  // bt_counter_clearall
  // 
  Self.bt_counter_clearall.Location := System.Drawing.Point.Create(376, 72);
  Self.bt_counter_clearall.Name := 'bt_counter_clearall';
  Self.bt_counter_clearall.Size := System.Drawing.Size.Create(48, 24);
  Self.bt_counter_clearall.TabIndex := 16;
  Self.bt_counter_clearall.Text := 'Read';
  Include(Self.bt_counter_clearall.Click, Self.bt_counter_clearall_Click);
  // 
  // bt_counter_clear1
  // 
  Self.bt_counter_clear1.Location := System.Drawing.Point.Create(376, 40);
  Self.bt_counter_clear1.Name := 'bt_counter_clear1';
  Self.bt_counter_clear1.Size := System.Drawing.Size.Create(48, 24);
  Self.bt_counter_clear1.TabIndex := 15;
  Self.bt_counter_clear1.Text := 'Read';
  Include(Self.bt_counter_clear1.Click, Self.bt_counter_clear1_Click);
  // 
  // bt_counter_clear0
  // 
  Self.bt_counter_clear0.Location := System.Drawing.Point.Create(376, 16);
  Self.bt_counter_clear0.Name := 'bt_counter_clear0';
  Self.bt_counter_clear0.Size := System.Drawing.Size.Create(48, 24);
  Self.bt_counter_clear0.TabIndex := 14;
  Self.bt_counter_clear0.Text := 'Clear';
  Include(Self.bt_counter_clear0.Click, Self.bt_counter_clear0_Click);
  // 
  // bt_counter_readall
  // 
  Self.bt_counter_readall.Location := System.Drawing.Point.Create(320, 72);
  Self.bt_counter_readall.Name := 'bt_counter_readall';
  Self.bt_counter_readall.Size := System.Drawing.Size.Create(48, 24);
  Self.bt_counter_readall.TabIndex := 13;
  Self.bt_counter_readall.Text := 'Read';
  Include(Self.bt_counter_readall.Click, Self.bt_counter_readall_Click);
  // 
  // bt_counter_read1
  // 
  Self.bt_counter_read1.Location := System.Drawing.Point.Create(320, 40);
  Self.bt_counter_read1.Name := 'bt_counter_read1';
  Self.bt_counter_read1.Size := System.Drawing.Size.Create(48, 24);
  Self.bt_counter_read1.TabIndex := 12;
  Self.bt_counter_read1.Text := 'Read';
  Include(Self.bt_counter_read1.Click, Self.bt_counter_read1_Click);
  // 
  // bt_counter_read0
  // 
  Self.bt_counter_read0.Location := System.Drawing.Point.Create(320, 16);
  Self.bt_counter_read0.Name := 'bt_counter_read0';
  Self.bt_counter_read0.Size := System.Drawing.Size.Create(48, 24);
  Self.bt_counter_read0.TabIndex := 11;
  Self.bt_counter_read0.Text := 'Read';
  Include(Self.bt_counter_read0.Click, Self.bt_counter_read0_Click);
  // 
  // tb_counter1
  // 
  Self.tb_counter1.Location := System.Drawing.Point.Create(240, 40);
  Self.tb_counter1.Name := 'tb_counter1';
  Self.tb_counter1.Size := System.Drawing.Size.Create(72, 20);
  Self.tb_counter1.TabIndex := 10;
  Self.tb_counter1.Text := '0';
  // 
  // tb_counter0
  // 
  Self.tb_counter0.Location := System.Drawing.Point.Create(240, 16);
  Self.tb_counter0.Name := 'tb_counter0';
  Self.tb_counter0.Size := System.Drawing.Size.Create(72, 20);
  Self.tb_counter0.TabIndex := 9;
  Self.tb_counter0.Text := '0';
  // 
  // bt_inputs_read
  // 
  Self.bt_inputs_read.Location := System.Drawing.Point.Create(96, 72);
  Self.bt_inputs_read.Name := 'bt_inputs_read';
  Self.bt_inputs_read.Size := System.Drawing.Size.Create(72, 24);
  Self.bt_inputs_read.TabIndex := 8;
  Self.bt_inputs_read.Text := 'Read all';
  Include(Self.bt_inputs_read.Click, Self.bt_inputs_read_Click);
  // 
  // bt_outputs_read
  // 
  Self.bt_outputs_read.Location := System.Drawing.Point.Create(16, 72);
  Self.bt_outputs_read.Name := 'bt_outputs_read';
  Self.bt_outputs_read.Size := System.Drawing.Size.Create(72, 24);
  Self.bt_outputs_read.TabIndex := 7;
  Self.bt_outputs_read.Text := 'Read all';
  Include(Self.bt_outputs_read.Click, Self.bt_outputs_read_Click);
  // 
  // ln_counterall
  // 
  Self.ln_counterall.Location := System.Drawing.Point.Create(176, 72);
  Self.ln_counterall.Name := 'ln_counterall';
  Self.ln_counterall.Size := System.Drawing.Size.Create(64, 16);
  Self.ln_counterall.TabIndex := 6;
  Self.ln_counterall.Text := 'Counter all';
  // 
  // lb_counter1
  // 
  Self.lb_counter1.Location := System.Drawing.Point.Create(176, 48);
  Self.lb_counter1.Name := 'lb_counter1';
  Self.lb_counter1.Size := System.Drawing.Size.Create(56, 16);
  Self.lb_counter1.TabIndex := 5;
  Self.lb_counter1.Text := 'Counter 1';
  // 
  // lb_counter0
  // 
  Self.lb_counter0.Location := System.Drawing.Point.Create(176, 24);
  Self.lb_counter0.Name := 'lb_counter0';
  Self.lb_counter0.Size := System.Drawing.Size.Create(56, 16);
  Self.lb_counter0.TabIndex := 4;
  Self.lb_counter0.Text := 'Counter 0';
  // 
  // cb_input1
  // 
  Self.cb_input1.Location := System.Drawing.Point.Create(96, 48);
  Self.cb_input1.Name := 'cb_input1';
  Self.cb_input1.Size := System.Drawing.Size.Create(64, 16);
  Self.cb_input1.TabIndex := 3;
  Self.cb_input1.Text := 'Input 1';
  // 
  // cb_input0
  // 
  Self.cb_input0.Location := System.Drawing.Point.Create(96, 24);
  Self.cb_input0.Name := 'cb_input0';
  Self.cb_input0.Size := System.Drawing.Size.Create(64, 16);
  Self.cb_input0.TabIndex := 2;
  Self.cb_input0.Text := 'Input 0';
  // 
  // cb_output1
  // 
  Self.cb_output1.Location := System.Drawing.Point.Create(16, 48);
  Self.cb_output1.Name := 'cb_output1';
  Self.cb_output1.Size := System.Drawing.Size.Create(88, 16);
  Self.cb_output1.TabIndex := 1;
  Self.cb_output1.Text := 'Output 1';
  Include(Self.cb_output1.MouseUp, Self.cb_output1_MouseUp);
  // 
  // cb_output0
  // 
  Self.cb_output0.Location := System.Drawing.Point.Create(16, 24);
  Self.cb_output0.Name := 'cb_output0';
  Self.cb_output0.Size := System.Drawing.Size.Create(88, 16);
  Self.cb_output0.TabIndex := 0;
  Self.cb_output0.Text := 'Output 0';
  Include(Self.cb_output0.MouseUp, Self.cb_output0_MouseUp);
  // 
  // gb_connection
  // 
  Self.gb_connection.Controls.Add(Self.bt_disconnect);
  Self.gb_connection.Controls.Add(Self.bt_connect);
  Self.gb_connection.Controls.Add(Self.tb_password);
  Self.gb_connection.Controls.Add(Self.tb_port);
  Self.gb_connection.Controls.Add(Self.tb_ip);
  Self.gb_connection.Controls.Add(Self.lb_password);
  Self.gb_connection.Controls.Add(Self.lb_port);
  Self.gb_connection.Controls.Add(Self.lb_ip);
  Self.gb_connection.Location := System.Drawing.Point.Create(16, 160);
  Self.gb_connection.Name := 'gb_connection';
  Self.gb_connection.Size := System.Drawing.Size.Create(440, 80);
  Self.gb_connection.TabIndex := 1;
  Self.gb_connection.TabStop := False;
  Self.gb_connection.Text := 'Connection Control';
  // 
  // bt_disconnect
  // 
  Self.bt_disconnect.Enabled := False;
  Self.bt_disconnect.Location := System.Drawing.Point.Create(336, 48);
  Self.bt_disconnect.Name := 'bt_disconnect';
  Self.bt_disconnect.Size := System.Drawing.Size.Create(88, 24);
  Self.bt_disconnect.TabIndex := 7;
  Self.bt_disconnect.Text := 'Disconnect';
  Include(Self.bt_disconnect.Click, Self.bt_disconnect_Click);
  // 
  // bt_connect
  // 
  Self.bt_connect.Location := System.Drawing.Point.Create(336, 16);
  Self.bt_connect.Name := 'bt_connect';
  Self.bt_connect.Size := System.Drawing.Size.Create(88, 24);
  Self.bt_connect.TabIndex := 6;
  Self.bt_connect.Text := 'Connect';
  Include(Self.bt_connect.Click, Self.bt_connect_Click);
  // 
  // tb_password
  // 
  Self.tb_password.Location := System.Drawing.Point.Create(200, 48);
  Self.tb_password.Name := 'tb_password';
  Self.tb_password.Size := System.Drawing.Size.Create(128, 20);
  Self.tb_password.TabIndex := 5;
  Self.tb_password.Text := 'TextBox1';
  // 
  // tb_port
  // 
  Self.tb_port.Location := System.Drawing.Point.Create(144, 48);
  Self.tb_port.Name := 'tb_port';
  Self.tb_port.Size := System.Drawing.Size.Create(48, 20);
  Self.tb_port.TabIndex := 4;
  Self.tb_port.Text := '80';
  // 
  // tb_ip
  // 
  Self.tb_ip.Location := System.Drawing.Point.Create(16, 48);
  Self.tb_ip.Name := 'tb_ip';
  Self.tb_ip.Size := System.Drawing.Size.Create(120, 20);
  Self.tb_ip.TabIndex := 3;
  Self.tb_ip.Text := '';
  // 
  // lb_password
  // 
  Self.lb_password.Location := System.Drawing.Point.Create(200, 32);
  Self.lb_password.Name := 'lb_password';
  Self.lb_password.Size := System.Drawing.Size.Create(56, 16);
  Self.lb_password.TabIndex := 2;
  Self.lb_password.Text := 'Password';
  // 
  // lb_port
  // 
  Self.lb_port.Location := System.Drawing.Point.Create(144, 32);
  Self.lb_port.Name := 'lb_port';
  Self.lb_port.Size := System.Drawing.Size.Create(40, 16);
  Self.lb_port.TabIndex := 1;
  Self.lb_port.Text := 'Port';
  // 
  // lb_ip
  // 
  Self.lb_ip.Location := System.Drawing.Point.Create(16, 32);
  Self.lb_ip.Name := 'lb_ip';
  Self.lb_ip.Size := System.Drawing.Size.Create(80, 16);
  Self.lb_ip.TabIndex := 0;
  Self.lb_ip.Text := 'IP Address';
  // 
  // StatusBar1
  // 
  Self.StatusBar1.Location := System.Drawing.Point.Create(0, 254);
  Self.StatusBar1.Name := 'StatusBar1';
  Self.StatusBar1.Size := System.Drawing.Size.Create(472, 16);
  Self.StatusBar1.TabIndex := 2;
  Self.StatusBar1.Text := 'No Connection';
  // 
  // timer_polling
  // 
  Self.timer_polling.Interval := 250;
  Include(Self.timer_polling.Tick, Self.timer_polling_Tick1);
  // 
  // TWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(472, 270);
  Self.Controls.Add(Self.StatusBar1);
  Self.Controls.Add(Self.gb_connection);
  Self.Controls.Add(Self.gb_io);
  Self.Name := 'TWinForm';
  Self.Text := 'Web-IO Assci Client';
  //Include(Self.Load, Self.TWinForm_Load);
  Self.gb_io.ResumeLayout(False);
  Self.gb_connection.ResumeLayout(False);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

var
      TCP_Client : Socket;
      ReceiveBuffer : array [0..512] of byte;
      ar : IAsyncResult;

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm.Create;
begin
  inherited Create;
  //
  // Erforderlich fr die Untersttzung des Windows Forms-Designers
  //
  InitializeComponent;
  //
  // TODO: Fgen Sie nach dem Aufruf von InitializeComponent Konstruktorcode hinzu.
  //
end;

//# Connecting to Web-IO #
procedure TWinForm.bt_connect_Click(sender: System.Object; e: System.EventArgs);
var WebioEP : IPEndPoint;
begin
   if (tb_ip.Text <> '') and (tb_port.Text <> '') then
   begin
     bt_connect.Enabled := false;
     WebioEP := IPEndPoint.Create(IPaddress.Parse(tb_ip.Text),
                convert.ToInt16(tb_port.Text ));
     TCP_Client := Socket.Create (AddressFamily.InterNetwork,
                   SocketType.Stream, ProtocolType.TCP);
     StatusBar1.Text := 'Try to connect to ' + tb_ip.Text;
     timer_polling.Enabled := true;
     try
       TCP_Client.BeginConnect(WebioEP, callback_connect, TCP_Client);
     except on ex : Exception do
       begin
         StatusBar1.Text := 'ERROR on connecting';
         close();
       end;
     end;
   end;
end;

procedure  TWinForm.callback_connect(ari : IAsyncResult);
begin
  gb_io.enabled := true;
  bt_disconnect.Enabled := True;
  statusbar1.Text := 'Connected to ' + tb_ip.Text;
  try
    TCP_Client.EndConnect(ari);
    TCP_Client.BeginReceive(ReceiveBuffer, 0, 512,
       SocketFlags.None, callback_readdata, ari.AsyncState);
  except on ex : Exception do
    begin
      StatusBar1.Text := 'ERROR on connect: ' + ex.ToString;
      close();
    end;
  end;
end;

// # Close connection #
procedure TWinForm.bt_disconnect_Click
               (sender: System.Object; e: System.EventArgs);
begin
  close();
end;

procedure TWinForm.close();
begin
  timer_polling.Enabled := False;
  Try
    TCP_client.EndReceive(ar);
  except
  end;
  Try
    TCP_client.Shutdown(SocketShutdown.Both);
  except
  end;
  Try
    TCP_client.Close()
  except
  end;
  bt_connect.Enabled := True;
  gb_io.Enabled := False;
  bt_disconnect.Enabled := False;
  StatusBar1.Text := 'no connection';
end;

// # Receiving Data #
procedure TWinForm.callback_readdata(ari : IAsyncResult);
var
  bytesread : Integer;
  receivestring : string;
begin
  Try
    bytesread := TCP_Client.EndReceive(ari)
  except
  end;
  if Bytesread = 0 then close() else
  begin
    receivestring :=
         System.Text.Encoding.ASCII.GetString(ReceiveBuffer,0, bytesread);
    try
      TCP_Client.BeginReceive(ReceiveBuffer, 0, 512,
         SocketFlags.None, callback_readdata, ari.AsyncState);
    except on ex : Exception
    do
      begin
        statusbar1.Text := 'ERROR on read: ' + ex.ToString;
        close();
      end;  
    end;
    if receivestring[1] = 'o' then
    begin
      if (convert.ToInt16(receivestring[8]) and 1) = 1 then
        cb_output0.Checked := true
      else
        cb_output0.Checked := false;
      if (convert.ToInt16(receivestring[8]) and 2) = 2 then
        cb_output1.Checked := true
      else
        cb_output1.Checked := false;
    end;
    if receivestring[1] = 'i' then
    begin
      if (convert.ToInt16(receivestring[7]) and 1) = 1 then
        cb_input0.Checked := true
      else
        cb_input0.Checked := false;
      if (convert.ToInt16(receivestring[7]) and 2) = 2 then
        cb_input1.Checked := true
      else
        cb_input1.Checked := false;
    end;
    if receivestring[1] = 'c' then
    begin
      if copy(ReceiveString, 8, 1) = '0' then
        tb_counter0.Text := copy(ReceiveString, 10,length(ReceiveString)-10);
      if copy(ReceiveString, 8, 1) = '1' then
        tb_counter1.Text := copy(ReceiveString, 10,length(ReceiveString)-10);
      if copy(ReceiveString, 8, 1) = ';' then
      begin
        ReceiveString[8] := ' ';
        tb_counter0.Text := copy(ReceiveString, 9, pos(';',ReceiveString)-9);
        tb_counter1.Text := copy(ReceiveString,
        pos(';',ReceiveString)+1,
        length(ReceiveString)-pos(';',ReceiveString)-1);
      end;
    end;
  end;
end;

// # Sending commands to Web-IO #
procedure TWinForm.sendcommand(sendstring : String);
var
  SendBuffer : array [0..512] of byte;
begin
  SendBuffer := System.Text.Encoding.ASCII.GetBytes(sendstring);
  try
    TCP_Client.Send(SendBuffer, 0, sendstring.Length, SocketFlags.None );
  except on ex : Exception do
    begin
      StatusBar1.Text := 'ERROR on send: ' + ex.ToString;
      close();
    end;
  end;
end;

procedure TWinForm.cb_output0_MouseUp(sender: System.Object; e: System.Windows.Forms.MouseEventArgs);
begin
  if cb_output0.Checked Then
    sendcommand('GET /outputaccess0?PW=' + tb_password.Text + '&State=ON&')
  else
    sendcommand('GET /outputaccess0?PW=' + tb_password.Text + '&State=OFF&');
end;

procedure TWinForm.cb_output1_MouseUp(sender: System.Object; e: System.Windows.Forms.MouseEventArgs);
begin
    if cb_output1.Checked Then
    sendcommand('GET /outputaccess1?PW=' + tb_password.Text + '&State=ON&')
  else
    sendcommand('GET /outputaccess1?PW=' + tb_password.Text + '&State=OFF&');
end;

procedure TWinForm.bt_outputs_read_Click(sender: System.Object; e: System.EventArgs);
begin
  sendcommand('GET /output?PW=' + tb_password.Text + '&');
end;

procedure TWinForm.bt_inputs_read_Click(sender: System.Object; e: System.EventArgs);
begin
  sendcommand('GET /input?PW=' + tb_password.Text + '&');
end;

procedure TWinForm.bt_counter_read0_Click(sender: System.Object; e: System.EventArgs);
begin
  sendcommand('GET /counter0?PW=' + tb_password.Text + '&');
end;

procedure TWinForm.bt_counter_read1_Click(sender: System.Object; e: System.EventArgs);
begin
  sendcommand('GET /counter0?PW=' + tb_password.Text + '&');
end;

procedure TWinForm.bt_counter_readall_Click(sender: System.Object; e: System.EventArgs);
begin
  sendcommand('GET /counter?PW=' + tb_password.Text + '&');
end;

procedure TWinForm.bt_counter_clear0_Click(sender: System.Object; e: System.EventArgs);
begin
  sendcommand('GET /counterclear0?PW=' + tb_password.Text + '&');
end;

procedure TWinForm.bt_counter_clear1_Click(sender: System.Object; e: System.EventArgs);
begin
  sendcommand('GET /counterclear1?PW=' + tb_password.Text + '&');
end;

procedure TWinForm.bt_counter_clearall_Click(sender: System.Object; e: System.EventArgs);
begin
  sendcommand('GET /counterclear?PW=' + tb_password.Text + '&');
end;

// # Polling #
procedure TWinForm.timer_polling_Tick1(sender: System.Object; e: System.EventArgs);
begin
  if TCP_Client.Connected then
  begin
    if cb_output_polling.Checked then
      sendcommand('GET /output?PW=' + tb_password.Text + '&');
    if cb_input_polling.Checked then
      sendcommand('GET /input?PW=' + tb_password.Text + '&');
    if cb_counter_polling.Checked then
      sendcommand('GET /counter?PW=' + tb_password.Text + '&');
  end;
end;

procedure TWinForm.tb_interval_TextChanged(sender: System.Object; e: System.EventArgs);
begin
  timer_polling.Interval := convert.ToInt16(tb_interval.Text);
end;

end.
