// loginDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "login.h"
#include "loginDlg.h"
#include "mysocket.h"
#include "stdlib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

CMySocket g_MySocket;


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLoginDlg Dialogfeld

CLoginDlg::CLoginDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLoginDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLoginDlg)
	m_GetHttpLogin = _T("");
	m_SendHttpLogin = _T("");
	m_SendDummy = 0;
	m_GetDummy = 0;
	m_GetMainType = 0;
	m_GetSubType = 0;
	m_SendMainType = 0;
	m_SendSubType = 0;
	m_SendSourceIP = _T("");
	m_SendSourcePort = _T("");
	m_GetSourcePort = _T("");
	m_SendDestPort = _T("");
	m_GetDestPort = _T("");
	m_SendPassword = _T("");
	m_GetSourceIP = _T("");
	m_Ip = _T("");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLoginDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLoginDlg)
	DDX_Text(pDX, IDC_GETHTTPLOGIN, m_GetHttpLogin);
	DDX_Text(pDX, IDC_SENDHTTPLOGIN, m_SendHttpLogin);
	DDX_Text(pDX, IDC_SENDDUMMY, m_SendDummy);
	DDX_Text(pDX, IDC_GETDUMMY, m_GetDummy);
	DDX_Text(pDX, IDC_GETMAINTYPE, m_GetMainType);
	DDX_Text(pDX, IDC_GETSUBTYPE, m_GetSubType);
	DDX_Text(pDX, IDC_SENDMAINTYPE, m_SendMainType);
	DDX_Text(pDX, IDC_SENDSUBTYPE, m_SendSubType);
	DDX_Text(pDX, IDC_SENDSOURCEIP, m_SendSourceIP);
	DDX_Text(pDX, IDC_SENDSOURCEPORT, m_SendSourcePort);
	DDX_Text(pDX, IDC_GETSOURCEPORT, m_GetSourcePort);
	DDX_Text(pDX, IDC_SENDDESTPORT, m_SendDestPort);
	DDX_Text(pDX, IDC_GETDESTPORT, m_GetDestPort);
	DDX_Text(pDX, IDC_SENDPASSWORD, m_SendPassword);
	DDV_MaxChars(pDX, m_SendPassword, 31);
	DDX_Text(pDX, IDC_GETSOURCEIP, m_GetSourceIP);
	DDX_Text(pDX, IDC_IP, m_Ip);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLoginDlg, CDialog)
	//{{AFX_MSG_MAP(CLoginDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SENDBININFO, OnSendbininfo)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_WM_DESTROY()
	ON_EN_CHANGE(IDC_SENDDESTPORT, OnChangeSenddestport)
	ON_EN_CHANGE(IDC_SENDDUMMY, OnChangeSenddummy)
	ON_EN_CHANGE(IDC_SENDPASSWORD, OnChangeSendpassword)
	ON_EN_CHANGE(IDC_IP, OnChangeIp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLoginDlg Nachrichten-Handler

BOOL CLoginDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen

	//initializing variables
	g_MySocket.m_pLoginDlg=this;

	m_SendHttpLogin="GET /bin?LPW=&";
	m_SendPassword="";
	m_SendDummy=0x00;
	m_SendMainType=0x04;
	m_SendSubType=0x00;
	m_SendSourcePort="0";
	m_SendDestPort="49153";
	m_SendSourceIP="";

	m_GetHttpLogin="";
	m_GetDummy=0x00;
	m_GetMainType=0x00;
	m_GetSubType=0x00;
	m_GetSourcePort="0";
	m_GetDestPort="49153";

	m_Ip="";

	//update screen
	UpdateData(FALSE);

	// enable/disable Buttons
	GetDlgItem(IDC_SENDHTTPLOGIN)->EnableWindow(FALSE);
	GetDlgItem(IDC_SENDDUMMY)->EnableWindow(FALSE);
	GetDlgItem(IDC_SENDMAINTYPE)->EnableWindow(FALSE);
	GetDlgItem(IDC_SENDSUBTYPE)->EnableWindow(FALSE);
	GetDlgItem(IDC_SENDSOURCEPORT)->EnableWindow(FALSE);
	GetDlgItem(IDC_GETHTTPLOGIN)->EnableWindow(FALSE);
	GetDlgItem(IDC_GETDUMMY)->EnableWindow(FALSE);
	GetDlgItem(IDC_GETMAINTYPE)->EnableWindow(FALSE);
	GetDlgItem(IDC_GETSUBTYPE)->EnableWindow(FALSE);
	GetDlgItem(IDC_GETSOURCEPORT)->EnableWindow(FALSE);
	GetDlgItem(IDC_GETSOURCEIP)->EnableWindow(FALSE);
	GetDlgItem(IDC_GETDESTPORT)->EnableWindow(FALSE);

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CLoginDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CLoginDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CLoginDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//button "send bininfo"
void CLoginDlg::OnSendbininfo() 
{
	UpdateData(TRUE);
	//declare assisting variables and a buffer
	BYTE b0,b1,b2,b3;
	BYTE *Buffer= new BYTE[512];
	
	//create loginstring from 2 editboxes and write it into buffer
	CString loginstring=m_SendHttpLogin;
	loginstring.Insert(13,m_SendPassword);
	for (int j=0; j<loginstring.GetLength(); j++)
		Buffer[j]=loginstring[j];

	//create 2 BYTE values from WORD
	b0=_rotr((0xFF00) & m_SendDummy,8);
	b1=(0x00FF) & m_SendDummy;

	//write information into buffer after the already inserted loginstring
	//WORDS and LONG attention!!!  
	//===LOW BYTE FIRST===

	//write dummy into buffer
	Buffer[loginstring.GetLength()]=b1;
	Buffer[loginstring.GetLength() + 1]=b0;
	//write type and subtype into buffer
	Buffer[loginstring.GetLength() + 2]=m_SendMainType;
	Buffer[loginstring.GetLength() + 3]=m_SendSubType;

	//get 4 BYTES from the IP String
	sscanf(m_SendSourceIP,"%d.%d.%d.%d",&b0,&b1,&b2,&b3);

	//and write them into buffer
	Buffer[loginstring.GetLength() + 4]=b3;
	Buffer[loginstring.GetLength() + 5]=b2;
	Buffer[loginstring.GetLength() + 6]=b1;
	Buffer[loginstring.GetLength() + 7]=b0;

	//WORD value SourcePort
	b0=_rotr((0xFF00) & atoi(m_SendSourcePort),8);
	b1=(0x00FF) & atoi(m_SendSourcePort);
	Buffer[loginstring.GetLength() + 8]=b1;
	Buffer[loginstring.GetLength() + 9]=b0;
	
	//WORD value DestinationPort
	b0=_rotr((0xFF00) & atoi(m_SendDestPort),8);
	b1=(0x00FF) & atoi(m_SendDestPort);
	Buffer[loginstring.GetLength() + 10]=b1;
	Buffer[loginstring.GetLength() + 11]=b0;

	//send buffer
	g_MySocket.Send(Buffer,12+loginstring.GetLength());

	//free dynamic buffer
	delete[] Buffer;

}


void CLoginDlg::OnReceive()
{


	int recieved;	//value of data
	//dynamic buffer with maximum size of web-IO transmittation capability
	BYTE* pBuffer =new BYTE[512];
	BYTE b0,b1,b2,b3;
	char get[20];
	CString login;
	
	//recieve method returning transmission value  
	recieved=g_MySocket.Receive(pBuffer,512);

	//catch errors
	if (recieved==SOCKET_ERROR)
		MessageBox("Socket Error");
	else
	{
		//what kind of package have we here??
		//11th and 12th BYTE in the received buffer contains Type and Subtype
		
		if (pBuffer[10]==0x02)
		{
			switch (pBuffer[11])
			{
		
			case 0x01:
				MessageBox("Access granted");
				break;
			case 0x02:
				MessageBox("Connection already in use");
				break;
			case 0x04:
				MessageBox("Web-IO is ready for binary access in a few seconds");
				break;
			case 0x07:
				MessageBox("Wrong Password");
				break;
			case 0x08:
				MessageBox("Wrong Destination Port");
				break;
			case 0x09:
				MessageBox("Modus mismatch");
				break;
			};
			
			//read GetHttpLogin from Buffer
			for (int i=0;i<8;i++) m_GetHttpLogin.Insert(i,pBuffer[i]);

			//get Type and Subtype		
			m_GetMainType=pBuffer[10];
			m_GetSubType=pBuffer[11];

			//read IP from recieved data (===LOW BYTE FIRST===)
			b3=pBuffer[12];
			b2=pBuffer[13];
			b1=pBuffer[14];
			b0=pBuffer[15];

			sprintf(m_GetSourceIP.GetBuffer(1),"%d.%d.%d.%d", b0,b1,b2,b3);

			//read SourcePort from received data
			b1=pBuffer[16];
			b0=pBuffer[17];

			m_GetSourcePort=itoa((b0*0x100) + b1,get,10);

			//read DestinationPort from received data
			b1=pBuffer[18];
			b0=pBuffer[19];

			m_GetDestPort=itoa(((b0*0x100) + b1),get,10);

			//update screen
			UpdateData(FALSE);


		}
		else if (pBuffer[10]==0x03) MessageBox("Connection NOT accepted!");
	}

	//free dynamic buffer
	delete[] pBuffer;

}


void CLoginDlg::OnConnect() 
{
	//close eventually existing old socket and create a new one
	g_MySocket.Close();
	g_MySocket.Create();

	//update variables
	UpdateData(TRUE);

	//set up connection
	if (m_Ip!="")
	{
		if (g_MySocket.Connect(m_Ip,80)) MessageBox("Connected");
		else MessageBox("Connection error");
	}
	else MessageBox("Fill in IP-Address completely.");
}


void CLoginDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	g_MySocket.Close();	
}

//update different editbox-variables on change
void CLoginDlg::OnChangeSenddestport() 
{
	UpdateData(TRUE);
	
}

void CLoginDlg::OnChangeSenddummy() 
{
	UpdateData(TRUE);
}

void CLoginDlg::OnChangeSendpassword() 
{
	UpdateData(TRUE);	
}

void CLoginDlg::OnChangeIp() 
{
	UpdateData(TRUE);	
}
