#if !defined(AFX_STATUSBARCLIENT_H__3F05E733_D6E9_493E_BCE3_27B021C48300__INCLUDED_)
#define AFX_STATUSBARCLIENT_H__3F05E733_D6E9_493E_BCE3_27B021C48300__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Mit Microsoft Visual C++ automatisch erstellte IDispatch-Kapselungsklasse(n). 

// HINWEIS: Die Inhalte dieser Datei nicht ndern. Wenn Microsoft Visual C++
// diese Klasse erneuert, werden Ihre nderungen berschrieben.


// Dispatch-Schnittstellen, auf die von dieser Schnittstelle verwiesen wird
class CPanels;
class CPicture;
class COleFont;

/////////////////////////////////////////////////////////////////////////////
// Wrapper-Klasse CStatusBarClient 

class CStatusBarClient : public CWnd
{
protected:
	DECLARE_DYNCREATE(CStatusBarClient)
public:
	CLSID const& GetClsid()
	{
		static CLSID const clsid
			= { 0x8e3867a3, 0x8586, 0x11d1, { 0xb1, 0x6a, 0x0, 0xc0, 0xf0, 0x28, 0x36, 0x28 } };
		return clsid;
	}
	virtual BOOL Create(LPCTSTR lpszClassName,
		LPCTSTR lpszWindowName, DWORD dwStyle,
		const RECT& rect,
		CWnd* pParentWnd, UINT nID,
		CCreateContext* pContext = NULL)
	{ return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID); }

    BOOL Create(LPCTSTR lpszWindowName, DWORD dwStyle,
		const RECT& rect, CWnd* pParentWnd, UINT nID,
		CFile* pPersist = NULL, BOOL bStorage = FALSE,
		BSTR bstrLicKey = NULL)
	{ return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID,
		pPersist, bStorage, bstrLicKey); }

// Attribute
public:

// Operationen
public:
	CString GetSimpleText();
	void SetSimpleText(LPCTSTR lpszNewValue);
	long GetStyle();
	void SetStyle(long nNewValue);
	CPanels GetPanels();
	void SetRefPanels(LPDISPATCH newValue);
	long GetMousePointer();
	void SetMousePointer(long nNewValue);
	CPicture GetMouseIcon();
	void SetMouseIcon(LPDISPATCH newValue);
	void SetRefMouseIcon(LPDISPATCH newValue);
	BOOL GetShowTips();
	void SetShowTips(BOOL bNewValue);
	long GetOLEDropMode();
	void SetOLEDropMode(long nNewValue);
	BOOL GetEnabled();
	void SetEnabled(BOOL bNewValue);
	COleFont GetFont();
	void SetRefFont(LPDISPATCH newValue);
	long GetHWnd();
	void SetHWnd(long nNewValue);
	void Refresh();
	void OLEDrag();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // AFX_STATUSBARCLIENT_H__3F05E733_D6E9_493E_BCE3_27B021C48300__INCLUDED_
